package eu.ipac.ace.gmf.ipacadl.diagram.edit.parts;

import java.util.List;

import org.eclipse.draw2d.FigureUtilities;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteEntry;
import org.eclipse.gef.palette.PaletteStack;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.runtime.notation.impl.NodeImpl;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Text;

import eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlVisualIDRegistry;
import eu.ipac.ace.gmf.ipacadl.impl.InvokeStatementImpl;

/**
 * @generated NOT
 */
public class IpacadlEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		
		String creationToolsDescription = null;
		String theNameOfService = null;
		String theNameOfMethod = null;
		boolean startsWith = false;
		String descriptionOfEditPart;
		List ListOfToolGroups;
		
		if (model instanceof View) {
			View view = (View) model;
			switch (IpacadlVisualIDRegistry.getVisualID(view)) {

			case ApplicationEditPart.VISUAL_ID:
				return new ApplicationEditPart(view);

			case BodyEditPart.VISUAL_ID:
				return new BodyEditPart(view);

			case VectorDeclarationEditPart.VISUAL_ID:
				return new VectorDeclarationEditPart(view);

			case VectorDeclarationNameEditPart.VISUAL_ID:
				return new VectorDeclarationNameEditPart(view);

			case VariableDeclarationEditPart.VISUAL_ID:
				return new VariableDeclarationEditPart(view);

			case VariableDeclarationNameEditPart.VISUAL_ID:
				return new VariableDeclarationNameEditPart(view);

			case ConstantDeclarationEditPart.VISUAL_ID:
				return new ConstantDeclarationEditPart(view);

			case ConstantDeclarationNameEditPart.VISUAL_ID:
				return new ConstantDeclarationNameEditPart(view);

			case EventHandlerEditPart.VISUAL_ID:
				return new EventHandlerEditPart(view);

			case EventHandlerNameEditPart.VISUAL_ID:
				return new EventHandlerNameEditPart(view);

			case WaitStatementEditPart.VISUAL_ID:
				return new WaitStatementEditPart(view);

			case WaitStatementSecsEditPart.VISUAL_ID:
				return new WaitStatementSecsEditPart(view);

			case BreakStatementEditPart.VISUAL_ID:
				return new BreakStatementEditPart(view);

			case InvokeStatementEditPart.VISUAL_ID:
				return new InvokeStatementEditPart(view);

			case InvokeStatementComponentNameEditPart.VISUAL_ID:
				creationToolsDescription = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool;
				theNameOfService = null;
				startsWith = creationToolsDescription.startsWith("Service: ");
				if(startsWith){
					int positionOfComma = creationToolsDescription.indexOf(", ");
					theNameOfService = creationToolsDescription.substring(9, positionOfComma);
					if (model instanceof EObject){
						EObject theInvokeStatement = ((EObject) model).eContainer();
						if(theInvokeStatement instanceof NodeImpl){
							EObject finalInvokeStatement = ((NodeImpl) theInvokeStatement).getElement();
							finalInvokeStatement.eSetDeliver(false);
							((InvokeStatementImpl) finalInvokeStatement).setComponentName(theNameOfService);
							finalInvokeStatement.eSetDeliver(true);
						}
					}
				}
				return new InvokeStatementComponentNameEditPart(view);

			case InvokeStatementMethodNameEditPart.VISUAL_ID:
				creationToolsDescription = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool;
				theNameOfMethod = null;
				startsWith = creationToolsDescription.startsWith("Service: ");
				if(startsWith){
					int positionOfComma = creationToolsDescription.indexOf(", ");
					theNameOfMethod = creationToolsDescription.substring(positionOfComma+10);
					if (model instanceof EObject){
						EObject theInvokeStatement = ((EObject) model).eContainer();
						if(theInvokeStatement instanceof NodeImpl){
							EObject finalInvokeStatement = ((NodeImpl) theInvokeStatement).getElement();
							finalInvokeStatement.eSetDeliver(false);
							((InvokeStatementImpl) finalInvokeStatement).setMethodName(theNameOfMethod);
							finalInvokeStatement.eSetDeliver(true);
						}
					}
					eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool = "Invoke";
				}
				ListOfToolGroups = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.editorsPalette.getChildren();
				if(ListOfToolGroups.get(2) instanceof PaletteDrawer){
					List ListOfServicesCreationTools = ((PaletteDrawer) ListOfToolGroups.get(2)).getChildren();
					for (int i=0; i<ListOfServicesCreationTools.size(); i++){
						if(ListOfServicesCreationTools.get(i) instanceof PaletteStack){
							List CreationToolOfEachMethod = ((PaletteStack)ListOfServicesCreationTools.get(i)).getChildren();
							((PaletteStack)ListOfServicesCreationTools.get(i)).setActiveEntry((PaletteEntry) CreationToolOfEachMethod.get(0));
						}
					}
				}
				return new InvokeStatementMethodNameEditPart(view);

			case FaultStatementEditPart.VISUAL_ID:
				return new FaultStatementEditPart(view);

			case WaitStatement2EditPart.VISUAL_ID:
				return new WaitStatement2EditPart(view);

			case WaitStatementSecs2EditPart.VISUAL_ID:
				return new WaitStatementSecs2EditPart(view);

			case BreakStatement2EditPart.VISUAL_ID:
				return new BreakStatement2EditPart(view);

			case InvokeStatement2EditPart.VISUAL_ID:
				return new InvokeStatement2EditPart(view);

			case InvokeStatementComponentName2EditPart.VISUAL_ID:
				creationToolsDescription = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool;
				theNameOfService = null;
				startsWith = creationToolsDescription.startsWith("Service: ");
				if(startsWith){
					int positionOfComma = creationToolsDescription.indexOf(", ");
					theNameOfService = creationToolsDescription.substring(9, positionOfComma);
					if (model instanceof EObject){
						EObject theInvokeStatement = ((EObject) model).eContainer();
						if(theInvokeStatement instanceof NodeImpl){
							EObject finalInvokeStatement = ((NodeImpl) theInvokeStatement).getElement();
							finalInvokeStatement.eSetDeliver(false);
							((InvokeStatementImpl) finalInvokeStatement).setComponentName(theNameOfService);
							finalInvokeStatement.eSetDeliver(true);
						}
					}
				}
				return new InvokeStatementComponentName2EditPart(view);

			case InvokeStatementMethodName2EditPart.VISUAL_ID:
				creationToolsDescription = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool;
				theNameOfMethod = null;
				startsWith = creationToolsDescription.startsWith("Service: ");
				if(startsWith){
					int positionOfComma = creationToolsDescription.indexOf(", ");
					theNameOfMethod = creationToolsDescription.substring(positionOfComma+10);
					if (model instanceof EObject){
						EObject theInvokeStatement = ((EObject) model).eContainer();
						if(theInvokeStatement instanceof NodeImpl){
							EObject finalInvokeStatement = ((NodeImpl) theInvokeStatement).getElement();
							finalInvokeStatement.eSetDeliver(false);
							((InvokeStatementImpl) finalInvokeStatement).setMethodName(theNameOfMethod);
							finalInvokeStatement.eSetDeliver(true);
						}
					}
					eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool = "Invoke";
				}
				ListOfToolGroups = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.editorsPalette.getChildren();
				if(ListOfToolGroups.get(2) instanceof PaletteDrawer){
					List ListOfServicesCreationTools = ((PaletteDrawer) ListOfToolGroups.get(2)).getChildren();
					for (int i=0; i<ListOfServicesCreationTools.size(); i++){
						if(ListOfServicesCreationTools.get(i) instanceof PaletteStack){
							List CreationToolOfEachMethod = ((PaletteStack)ListOfServicesCreationTools.get(i)).getChildren();
							((PaletteStack)ListOfServicesCreationTools.get(i)).setActiveEntry((PaletteEntry) CreationToolOfEachMethod.get(0));
						}
					}
				}
				return new InvokeStatementMethodName2EditPart(view);

			case IterationStatementEditPart.VISUAL_ID:
				return new IterationStatementEditPart(view);

			case ExpressionEditPart.VISUAL_ID:
				return new ExpressionEditPart(view);

			case ExpressionStrExpressionEditPart.VISUAL_ID:
				return new ExpressionStrExpressionEditPart(view);

			case WaitStatement3EditPart.VISUAL_ID:
				return new WaitStatement3EditPart(view);

			case WaitStatementSecs3EditPart.VISUAL_ID:
				return new WaitStatementSecs3EditPart(view);

			case BreakStatement3EditPart.VISUAL_ID:
				return new BreakStatement3EditPart(view);

			case InvokeStatement3EditPart.VISUAL_ID:
				return new InvokeStatement3EditPart(view);

			case InvokeStatementComponentName3EditPart.VISUAL_ID:
				creationToolsDescription = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool;
				theNameOfService = null;
				startsWith = creationToolsDescription.startsWith("Service: ");
				if(startsWith){
					int positionOfComma = creationToolsDescription.indexOf(", ");
					theNameOfService = creationToolsDescription.substring(9, positionOfComma);
					if (model instanceof EObject){
						EObject theInvokeStatement = ((EObject) model).eContainer();
						if(theInvokeStatement instanceof NodeImpl){
							EObject finalInvokeStatement = ((NodeImpl) theInvokeStatement).getElement();
							finalInvokeStatement.eSetDeliver(false);
							((InvokeStatementImpl) finalInvokeStatement).setComponentName(theNameOfService);
							finalInvokeStatement.eSetDeliver(true);
						}
					}
				}
				return new InvokeStatementComponentName3EditPart(view);

			case InvokeStatementMethodName3EditPart.VISUAL_ID:
				creationToolsDescription = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool;
				theNameOfMethod = null;
				startsWith = creationToolsDescription.startsWith("Service: ");
				if(startsWith){
					int positionOfComma = creationToolsDescription.indexOf(", ");
					theNameOfMethod = creationToolsDescription.substring(positionOfComma+10);
					if (model instanceof EObject){
						EObject theInvokeStatement = ((EObject) model).eContainer();
						if(theInvokeStatement instanceof NodeImpl){
							EObject finalInvokeStatement = ((NodeImpl) theInvokeStatement).getElement();
							finalInvokeStatement.eSetDeliver(false);
							((InvokeStatementImpl) finalInvokeStatement).setMethodName(theNameOfMethod);
							finalInvokeStatement.eSetDeliver(true);
						}
					}
					eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool = "Invoke";
				}
				ListOfToolGroups = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.editorsPalette.getChildren();
				if(ListOfToolGroups.get(2) instanceof PaletteDrawer){
					List ListOfServicesCreationTools = ((PaletteDrawer) ListOfToolGroups.get(2)).getChildren();
					for (int i=0; i<ListOfServicesCreationTools.size(); i++){
						if(ListOfServicesCreationTools.get(i) instanceof PaletteStack){
							List CreationToolOfEachMethod = ((PaletteStack)ListOfServicesCreationTools.get(i)).getChildren();
							((PaletteStack)ListOfServicesCreationTools.get(i)).setActiveEntry((PaletteEntry) CreationToolOfEachMethod.get(0));
						}
					}
				}
				return new InvokeStatementMethodName3EditPart(view);

			case IterationStatement2EditPart.VISUAL_ID:
				return new IterationStatement2EditPart(view);

			case IfStatementEditPart.VISUAL_ID:
				return new IfStatementEditPart(view);

			case Expression2EditPart.VISUAL_ID:
				return new Expression2EditPart(view);

			case ExpressionStrExpression2EditPart.VISUAL_ID:
				return new ExpressionStrExpression2EditPart(view);

			case WaitStatement4EditPart.VISUAL_ID:
				return new WaitStatement4EditPart(view);

			case WaitStatementSecs4EditPart.VISUAL_ID:
				return new WaitStatementSecs4EditPart(view);

			case BreakStatement4EditPart.VISUAL_ID:
				return new BreakStatement4EditPart(view);

			case InvokeStatement4EditPart.VISUAL_ID:
				return new InvokeStatement4EditPart(view);

			case InvokeStatementComponentName4EditPart.VISUAL_ID:
				creationToolsDescription = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool;
				theNameOfService = null;
				startsWith = creationToolsDescription.startsWith("Service: ");
				if(startsWith){
					int positionOfComma = creationToolsDescription.indexOf(", ");
					theNameOfService = creationToolsDescription.substring(9, positionOfComma);
					if (model instanceof EObject){
						EObject theInvokeStatement = ((EObject) model).eContainer();
						if(theInvokeStatement instanceof NodeImpl){
							EObject finalInvokeStatement = ((NodeImpl) theInvokeStatement).getElement();
							finalInvokeStatement.eSetDeliver(false);
							((InvokeStatementImpl) finalInvokeStatement).setComponentName(theNameOfService);
							finalInvokeStatement.eSetDeliver(true);
						}
					}
				}
				return new InvokeStatementComponentName4EditPart(view);

			case InvokeStatementMethodName4EditPart.VISUAL_ID:
				creationToolsDescription = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool;
				theNameOfMethod = null;
				startsWith = creationToolsDescription.startsWith("Service: ");
				if(startsWith){
					int positionOfComma = creationToolsDescription.indexOf(", ");
					theNameOfMethod = creationToolsDescription.substring(positionOfComma+10);
					if (model instanceof EObject){
						EObject theInvokeStatement = ((EObject) model).eContainer();
						if(theInvokeStatement instanceof NodeImpl){
							EObject finalInvokeStatement = ((NodeImpl) theInvokeStatement).getElement();
							finalInvokeStatement.eSetDeliver(false);
							((InvokeStatementImpl) finalInvokeStatement).setMethodName(theNameOfMethod);
							finalInvokeStatement.eSetDeliver(true);
						}
					}
					eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool = "Invoke";
				}
				ListOfToolGroups = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.editorsPalette.getChildren();
				if(ListOfToolGroups.get(2) instanceof PaletteDrawer){
					List ListOfServicesCreationTools = ((PaletteDrawer) ListOfToolGroups.get(2)).getChildren();
					for (int i=0; i<ListOfServicesCreationTools.size(); i++){
						if(ListOfServicesCreationTools.get(i) instanceof PaletteStack){
							List CreationToolOfEachMethod = ((PaletteStack)ListOfServicesCreationTools.get(i)).getChildren();
							((PaletteStack)ListOfServicesCreationTools.get(i)).setActiveEntry((PaletteEntry) CreationToolOfEachMethod.get(0));
						}
					}
				}
				return new InvokeStatementMethodName4EditPart(view);

			case IterationStatement3EditPart.VISUAL_ID:
				return new IterationStatement3EditPart(view);

			case AssignmentStatementEditPart.VISUAL_ID:
				return new AssignmentStatementEditPart(view);

			case Expression3EditPart.VISUAL_ID:
				return new Expression3EditPart(view);

			case ExpressionStrExpression3EditPart.VISUAL_ID:
				return new ExpressionStrExpression3EditPart(view);

			case InvokeStatement5EditPart.VISUAL_ID:
				return new InvokeStatement5EditPart(view);

			case InvokeStatementComponentName5EditPart.VISUAL_ID:
				creationToolsDescription = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool;
				theNameOfService = null;
				startsWith = creationToolsDescription.startsWith("Service: ");
				if(startsWith){
					int positionOfComma = creationToolsDescription.indexOf(", ");
					theNameOfService = creationToolsDescription.substring(9, positionOfComma);
					if (model instanceof EObject){
						EObject theInvokeStatement = ((EObject) model).eContainer();
						if(theInvokeStatement instanceof NodeImpl){
							EObject finalInvokeStatement = ((NodeImpl) theInvokeStatement).getElement();
							finalInvokeStatement.eSetDeliver(false);
							((InvokeStatementImpl) finalInvokeStatement).setComponentName(theNameOfService);
							finalInvokeStatement.eSetDeliver(true);
						}
					}
				}
				return new InvokeStatementComponentName5EditPart(view);

			case InvokeStatementMethodName5EditPart.VISUAL_ID:
				creationToolsDescription = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool;
				theNameOfMethod = null;
				startsWith = creationToolsDescription.startsWith("Service: ");
				if(startsWith){
					int positionOfComma = creationToolsDescription.indexOf(", ");
					theNameOfMethod = creationToolsDescription.substring(positionOfComma+10);
					if (model instanceof EObject){
						EObject theInvokeStatement = ((EObject) model).eContainer();
						if(theInvokeStatement instanceof NodeImpl){
							EObject finalInvokeStatement = ((NodeImpl) theInvokeStatement).getElement();
							finalInvokeStatement.eSetDeliver(false);
							((InvokeStatementImpl) finalInvokeStatement).setMethodName(theNameOfMethod);
							finalInvokeStatement.eSetDeliver(true);
						}
					}
					eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool = "Invoke";
				}
				ListOfToolGroups = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.editorsPalette.getChildren();
				if(ListOfToolGroups.get(2) instanceof PaletteDrawer){
					List ListOfServicesCreationTools = ((PaletteDrawer) ListOfToolGroups.get(2)).getChildren();
					for (int i=0; i<ListOfServicesCreationTools.size(); i++){
						if(ListOfServicesCreationTools.get(i) instanceof PaletteStack){
							List CreationToolOfEachMethod = ((PaletteStack)ListOfServicesCreationTools.get(i)).getChildren();
							((PaletteStack)ListOfServicesCreationTools.get(i)).setActiveEntry((PaletteEntry) CreationToolOfEachMethod.get(0));
						}
					}
				}
				return new InvokeStatementMethodName5EditPart(view);

			case IfStatement2EditPart.VISUAL_ID:
				return new IfStatement2EditPart(view);

			case AssignmentStatement2EditPart.VISUAL_ID:
				return new AssignmentStatement2EditPart(view);

			case WaitStatement5EditPart.VISUAL_ID:
				return new WaitStatement5EditPart(view);

			case WaitStatementSecs5EditPart.VISUAL_ID:
				return new WaitStatementSecs5EditPart(view);

			case BreakStatement5EditPart.VISUAL_ID:
				return new BreakStatement5EditPart(view);

			case InvokeStatement6EditPart.VISUAL_ID:
				return new InvokeStatement6EditPart(view);

			case InvokeStatementComponentName6EditPart.VISUAL_ID:
				creationToolsDescription = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool;
				theNameOfService = null;
				startsWith = creationToolsDescription.startsWith("Service: ");
				if(startsWith){
					int positionOfComma = creationToolsDescription.indexOf(", ");
					theNameOfService = creationToolsDescription.substring(9, positionOfComma);
					if (model instanceof EObject){
						EObject theInvokeStatement = ((EObject) model).eContainer();
						if(theInvokeStatement instanceof NodeImpl){
							EObject finalInvokeStatement = ((NodeImpl) theInvokeStatement).getElement();
							finalInvokeStatement.eSetDeliver(false);
							((InvokeStatementImpl) finalInvokeStatement).setComponentName(theNameOfService);
							finalInvokeStatement.eSetDeliver(true);
						}
					}
				}
				return new InvokeStatementComponentName6EditPart(view);

			case InvokeStatementMethodName6EditPart.VISUAL_ID:
				creationToolsDescription = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool;
				theNameOfMethod = null;
				startsWith = creationToolsDescription.startsWith("Service: ");
				if(startsWith){
					int positionOfComma = creationToolsDescription.indexOf(", ");
					theNameOfMethod = creationToolsDescription.substring(positionOfComma+10);
					if (model instanceof EObject){
						EObject theInvokeStatement = ((EObject) model).eContainer();
						if(theInvokeStatement instanceof NodeImpl){
							EObject finalInvokeStatement = ((NodeImpl) theInvokeStatement).getElement();
							finalInvokeStatement.eSetDeliver(false);
							((InvokeStatementImpl) finalInvokeStatement).setMethodName(theNameOfMethod);
							finalInvokeStatement.eSetDeliver(true);
						}
					}
					eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool = "Invoke";
				}
				ListOfToolGroups = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.editorsPalette.getChildren();
				if(ListOfToolGroups.get(2) instanceof PaletteDrawer){
					List ListOfServicesCreationTools = ((PaletteDrawer) ListOfToolGroups.get(2)).getChildren();
					for (int i=0; i<ListOfServicesCreationTools.size(); i++){
						if(ListOfServicesCreationTools.get(i) instanceof PaletteStack){
							List CreationToolOfEachMethod = ((PaletteStack)ListOfServicesCreationTools.get(i)).getChildren();
							((PaletteStack)ListOfServicesCreationTools.get(i)).setActiveEntry((PaletteEntry) CreationToolOfEachMethod.get(0));
						}
					}
				}
				return new InvokeStatementMethodName6EditPart(view);

			case IterationStatement4EditPart.VISUAL_ID:
				return new IterationStatement4EditPart(view);

			case IfStatement3EditPart.VISUAL_ID:
				return new IfStatement3EditPart(view);

			case AssignmentStatement3EditPart.VISUAL_ID:
				return new AssignmentStatement3EditPart(view);

			case IfStatement4EditPart.VISUAL_ID:
				return new IfStatement4EditPart(view);

			case AssignmentStatement4EditPart.VISUAL_ID:
				return new AssignmentStatement4EditPart(view);

			case IterationStatement5EditPart.VISUAL_ID:
				return new IterationStatement5EditPart(view);

			case IfStatement5EditPart.VISUAL_ID:
				return new IfStatement5EditPart(view);

			case AssignmentStatement5EditPart.VISUAL_ID:
				return new AssignmentStatement5EditPart(view);

			case BooleanLiteralEditPart.VISUAL_ID:
				return new BooleanLiteralEditPart(view);

			case DoubleLiteralEditPart.VISUAL_ID:
				return new DoubleLiteralEditPart(view);

			case IntegerLiteralEditPart.VISUAL_ID:
				return new IntegerLiteralEditPart(view);

			case StringLiteralEditPart.VISUAL_ID:
				return new StringLiteralEditPart(view);

			case BooleanLiteral2EditPart.VISUAL_ID:
				return new BooleanLiteral2EditPart(view);

			case DoubleLiteral2EditPart.VISUAL_ID:
				return new DoubleLiteral2EditPart(view);

			case IntegerLiteral2EditPart.VISUAL_ID:
				return new IntegerLiteral2EditPart(view);

			case StringLiteral2EditPart.VISUAL_ID:
				return new StringLiteral2EditPart(view);

			case EventAssignmentStatementEditPart.VISUAL_ID:
				return new EventAssignmentStatementEditPart(view);

			case EventAssignmentStatementPropIdEditPart.VISUAL_ID:
				return new EventAssignmentStatementPropIdEditPart(view);

			case WaitStatement6EditPart.VISUAL_ID:
				return new WaitStatement6EditPart(view);

			case WaitStatementSecs6EditPart.VISUAL_ID:
				return new WaitStatementSecs6EditPart(view);

			case BreakStatement6EditPart.VISUAL_ID:
				return new BreakStatement6EditPart(view);

			case InvokeStatement7EditPart.VISUAL_ID:
				return new InvokeStatement7EditPart(view);

			case InvokeStatementComponentName7EditPart.VISUAL_ID:
				creationToolsDescription = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool;
				theNameOfService = null;
				startsWith = creationToolsDescription.startsWith("Service: ");
				if(startsWith){
					int positionOfComma = creationToolsDescription.indexOf(", ");
					theNameOfService = creationToolsDescription.substring(9, positionOfComma);
					if (model instanceof EObject){
						EObject theInvokeStatement = ((EObject) model).eContainer();
						if(theInvokeStatement instanceof NodeImpl){
							EObject finalInvokeStatement = ((NodeImpl) theInvokeStatement).getElement();
							finalInvokeStatement.eSetDeliver(false);
							((InvokeStatementImpl) finalInvokeStatement).setComponentName(theNameOfService);
							finalInvokeStatement.eSetDeliver(true);
						}
					}
				}
				return new InvokeStatementComponentName7EditPart(view);

			case InvokeStatementMethodName7EditPart.VISUAL_ID:
				creationToolsDescription = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool;
				theNameOfMethod = null;
				startsWith = creationToolsDescription.startsWith("Service: ");
				if(startsWith){
					int positionOfComma = creationToolsDescription.indexOf(", ");
					theNameOfMethod = creationToolsDescription.substring(positionOfComma+10);
					if (model instanceof EObject){
						EObject theInvokeStatement = ((EObject) model).eContainer();
						if(theInvokeStatement instanceof NodeImpl){
							EObject finalInvokeStatement = ((NodeImpl) theInvokeStatement).getElement();
							finalInvokeStatement.eSetDeliver(false);
							((InvokeStatementImpl) finalInvokeStatement).setMethodName(theNameOfMethod);
							finalInvokeStatement.eSetDeliver(true);
						}
					}
					eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.descriptionOfEachCreationTool = "Invoke";
				}
				ListOfToolGroups = eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlPaletteFactory.editorsPalette.getChildren();
				if(ListOfToolGroups.get(2) instanceof PaletteDrawer){
					List ListOfServicesCreationTools = ((PaletteDrawer) ListOfToolGroups.get(2)).getChildren();
					for (int i=0; i<ListOfServicesCreationTools.size(); i++){
						if(ListOfServicesCreationTools.get(i) instanceof PaletteStack){
							List CreationToolOfEachMethod = ((PaletteStack)ListOfServicesCreationTools.get(i)).getChildren();
							((PaletteStack)ListOfServicesCreationTools.get(i)).setActiveEntry((PaletteEntry) CreationToolOfEachMethod.get(0));
						}
					}
				}
				return new InvokeStatementMethodName7EditPart(view);

			case IterationStatement6EditPart.VISUAL_ID:
				return new IterationStatement6EditPart(view);

			case IfStatement6EditPart.VISUAL_ID:
				return new IfStatement6EditPart(view);

			case AssignmentStatement6EditPart.VISUAL_ID:
				return new AssignmentStatement6EditPart(view);

			case BodyCompartmentStatementEditPart.VISUAL_ID:
				return new BodyCompartmentStatementEditPart(view);

			case FaultStatementCompartmentOnFaultStatementsEditPart.VISUAL_ID:
				return new FaultStatementCompartmentOnFaultStatementsEditPart(
						view);

			case IterationStatementCompartmentWhileExpressionEditPart.VISUAL_ID:
				return new IterationStatementCompartmentWhileExpressionEditPart(
						view);

			case IterationStatementCompartmentWhileStatementEditPart.VISUAL_ID:
				return new IterationStatementCompartmentWhileStatementEditPart(
						view);

			case IterationStatementCompartmentWhileExpression2EditPart.VISUAL_ID:
				return new IterationStatementCompartmentWhileExpression2EditPart(
						view);

			case IterationStatementCompartmentWhileStatement2EditPart.VISUAL_ID:
				return new IterationStatementCompartmentWhileStatement2EditPart(
						view);

			case IfStatementCompartmentIfExpressionEditPart.VISUAL_ID:
				return new IfStatementCompartmentIfExpressionEditPart(view);

			case IfStatementCompartmentIfStatementEditPart.VISUAL_ID:
				return new IfStatementCompartmentIfStatementEditPart(view);

			case IfStatementCompartmentElseStatementEditPart.VISUAL_ID:
				return new IfStatementCompartmentElseStatementEditPart(view);

			case IterationStatementCompartmentWhileExpression3EditPart.VISUAL_ID:
				return new IterationStatementCompartmentWhileExpression3EditPart(
						view);

			case IterationStatementCompartmentWhileStatement3EditPart.VISUAL_ID:
				return new IterationStatementCompartmentWhileStatement3EditPart(
						view);

			case IfStatementCompartmentIfExpression2EditPart.VISUAL_ID:
				return new IfStatementCompartmentIfExpression2EditPart(view);

			case IfStatementCompartmentIfStatement2EditPart.VISUAL_ID:
				return new IfStatementCompartmentIfStatement2EditPart(view);

			case IfStatementCompartmentElseStatement2EditPart.VISUAL_ID:
				return new IfStatementCompartmentElseStatement2EditPart(view);

			case IterationStatementCompartmentWhileExpression4EditPart.VISUAL_ID:
				return new IterationStatementCompartmentWhileExpression4EditPart(
						view);

			case IterationStatementCompartmentWhileStatement4EditPart.VISUAL_ID:
				return new IterationStatementCompartmentWhileStatement4EditPart(
						view);

			case IfStatementCompartmentIfExpression3EditPart.VISUAL_ID:
				return new IfStatementCompartmentIfExpression3EditPart(view);

			case IfStatementCompartmentIfStatement3EditPart.VISUAL_ID:
				return new IfStatementCompartmentIfStatement3EditPart(view);

			case IfStatementCompartmentElseStatement3EditPart.VISUAL_ID:
				return new IfStatementCompartmentElseStatement3EditPart(view);

			case IfStatementCompartmentIfExpression4EditPart.VISUAL_ID:
				return new IfStatementCompartmentIfExpression4EditPart(view);

			case IfStatementCompartmentIfStatement4EditPart.VISUAL_ID:
				return new IfStatementCompartmentIfStatement4EditPart(view);

			case IfStatementCompartmentElseStatement4EditPart.VISUAL_ID:
				return new IfStatementCompartmentElseStatement4EditPart(view);

			case IterationStatementCompartmentWhileExpression5EditPart.VISUAL_ID:
				return new IterationStatementCompartmentWhileExpression5EditPart(
						view);

			case IterationStatementCompartmentWhileStatement5EditPart.VISUAL_ID:
				return new IterationStatementCompartmentWhileStatement5EditPart(
						view);

			case IfStatementCompartmentIfExpression5EditPart.VISUAL_ID:
				return new IfStatementCompartmentIfExpression5EditPart(view);

			case IfStatementCompartmentIfStatement5EditPart.VISUAL_ID:
				return new IfStatementCompartmentIfStatement5EditPart(view);

			case IfStatementCompartmentElseStatement5EditPart.VISUAL_ID:
				return new IfStatementCompartmentElseStatement5EditPart(view);

			case EventHandlerCompartmentEventHandlerStatementsPropertiesEditPart.VISUAL_ID:
				return new EventHandlerCompartmentEventHandlerStatementsPropertiesEditPart(
						view);

			case IterationStatementCompartmentWhileExpression6EditPart.VISUAL_ID:
				return new IterationStatementCompartmentWhileExpression6EditPart(
						view);

			case IterationStatementCompartmentWhileStatement6EditPart.VISUAL_ID:
				return new IterationStatementCompartmentWhileStatement6EditPart(
						view);

			case IfStatementCompartmentIfExpression6EditPart.VISUAL_ID:
				return new IfStatementCompartmentIfExpression6EditPart(view);

			case IfStatementCompartmentIfStatement6EditPart.VISUAL_ID:
				return new IfStatementCompartmentIfStatement6EditPart(view);

			case IfStatementCompartmentElseStatement6EditPart.VISUAL_ID:
				return new IfStatementCompartmentElseStatement6EditPart(view);

			case StatementConnectionEditPart.VISUAL_ID:
				return new StatementConnectionEditPart(view);
			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		if (source.getFigure() instanceof WrappingLabel)
			return new TextCellEditorLocator((WrappingLabel) source.getFigure());
		else {
			return new LabelCellEditorLocator((Label) source.getFigure());
		}
	}

	/**
	 * @generated
	 */
	static private class TextCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private WrappingLabel wrapLabel;

		/**
		 * @generated
		 */
		public TextCellEditorLocator(WrappingLabel wrapLabel) {
			this.wrapLabel = wrapLabel;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getWrapLabel() {
			return wrapLabel;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getWrapLabel().getTextBounds().getCopy();
			getWrapLabel().translateToAbsolute(rect);
			if (getWrapLabel().isTextWrapOn()
					&& getWrapLabel().getText().length() > 0) {
				rect.setSize(new Dimension(text.computeSize(rect.width,
						SWT.DEFAULT)));
			} else {
				int avr = FigureUtilities.getFontMetrics(text.getFont())
						.getAverageCharWidth();
				rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
						SWT.DEFAULT)).expand(avr * 2, 0));
			}
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}

	/**
	 * @generated
	 */
	private static class LabelCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private Label label;

		/**
		 * @generated
		 */
		public LabelCellEditorLocator(Label label) {
			this.label = label;
		}

		/**
		 * @generated
		 */
		public Label getLabel() {
			return label;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getLabel().getTextBounds().getCopy();
			getLabel().translateToAbsolute(rect);
			int avr = FigureUtilities.getFontMetrics(text.getFont())
					.getAverageCharWidth();
			rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
					SWT.DEFAULT)).expand(avr * 2, 0));
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}
}
