package eu.ipac.ace.gmf.ipacadl.diagram.edit.parts;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.RoundedRectangle;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.core.edithelpers.CreateElementRequestAdapter;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.CreationEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.requests.CreateViewAndElementRequest;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Display;

import eu.ipac.ace.gmf.ipacadl.diagram.edit.policies.IterationStatement2ItemSemanticEditPolicy;
import eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlVisualIDRegistry;
import eu.ipac.ace.gmf.ipacadl.diagram.providers.IpacadlElementTypes;

/**
 * @generated
 */
public class IterationStatement2EditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2013;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public IterationStatement2EditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		installEditPolicy(EditPolicyRoles.CREATION_ROLE,
				new CreationEditPolicy() {
					public Command getCommand(Request request) {
						if (understandsRequest(request)) {
							if (request instanceof CreateViewAndElementRequest) {
								CreateElementRequestAdapter adapter = ((CreateViewAndElementRequest) request)
										.getViewAndElementDescriptor()
										.getCreateElementRequestAdapter();
								IElementType type = (IElementType) adapter
										.getAdapter(IElementType.class);
								if (type == IpacadlElementTypes.Expression_2009) {
									EditPart compartmentEditPart = getChildBySemanticHint(IpacadlVisualIDRegistry
											.getType(IterationStatementCompartmentWhileExpression2EditPart.VISUAL_ID));
									return compartmentEditPart == null ? null
											: compartmentEditPart
													.getCommand(request);
								}
							}
							return super.getCommand(request);
						}
						return null;
					}
				});
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new IterationStatement2ItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		LayoutEditPolicy lep = new LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child
						.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		WhileStatementFigure figure = new WhileStatementFigure();
		return primaryShape = figure;
	}

	/**
	 * @generated
	 */
	public WhileStatementFigure getPrimaryShape() {
		return (WhileStatementFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof IterationStatementCompartmentWhileExpression2EditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureCompartmentWhileExpression();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane
					.add(((IterationStatementCompartmentWhileExpression2EditPart) childEditPart)
							.getFigure());
			return true;
		}
		if (childEditPart instanceof IterationStatementCompartmentWhileStatement2EditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureCompartmentWhileStatements();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane
					.add(((IterationStatementCompartmentWhileStatement2EditPart) childEditPart)
							.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {

		if (childEditPart instanceof IterationStatementCompartmentWhileExpression2EditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureCompartmentWhileExpression();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane
					.remove(((IterationStatementCompartmentWhileExpression2EditPart) childEditPart)
							.getFigure());
			return true;
		}
		if (childEditPart instanceof IterationStatementCompartmentWhileStatement2EditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureCompartmentWhileStatements();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane
					.remove(((IterationStatementCompartmentWhileStatement2EditPart) childEditPart)
							.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {

		if (editPart instanceof IterationStatementCompartmentWhileExpression2EditPart) {
			return getPrimaryShape().getFigureCompartmentWhileExpression();
		}
		if (editPart instanceof IterationStatementCompartmentWhileStatement2EditPart) {
			return getPrimaryShape().getFigureCompartmentWhileStatements();
		}
		return super.getContentPaneFor(editPart);
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(getMapMode()
				.DPtoLP(-1), getMapMode().DPtoLP(-1));
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(getMapMode().DPtoLP(5));
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	public class WhileStatementFigure extends RoundedRectangle {

		/**
		 * @generated
		 */
		private RectangleFigure fFigureCompartmentWhileExpression;
		/**
		 * @generated
		 */
		private RoundedRectangle fFigureCompartmentWhileStatements;

		/**
		 * @generated
		 */
		public WhileStatementFigure() {
			this.setCornerDimensions(new Dimension(getMapMode().DPtoLP(8),
					getMapMode().DPtoLP(8)));
			this.setForegroundColor(ColorConstants.black);
			this.setBackgroundColor(ColorConstants.white);

			this.setFont(THIS_FONT);

			this.setMaximumSize(new Dimension(getMapMode().DPtoLP(20),
					getMapMode().DPtoLP(40)));
			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents() {

			fFigureCompartmentWhileExpression = new RectangleFigure();
			fFigureCompartmentWhileExpression
					.setForegroundColor(ColorConstants.black);
			fFigureCompartmentWhileExpression
					.setBackgroundColor(ColorConstants.lightBlue);
			fFigureCompartmentWhileExpression.setMaximumSize(new Dimension(
					getMapMode().DPtoLP(10000), getMapMode().DPtoLP(50)));

			this.add(fFigureCompartmentWhileExpression);

			WrappingLabel whileExpressionLabel1 = new WrappingLabel();
			whileExpressionLabel1.setText("WHILE");
			whileExpressionLabel1.setForegroundColor(ColorConstants.black);
			whileExpressionLabel1.setBackgroundColor(ColorConstants.lightBlue);

			whileExpressionLabel1.setFont(WHILEEXPRESSIONLABEL1_FONT);

			whileExpressionLabel1.setMaximumSize(new Dimension(getMapMode()
					.DPtoLP(10000), getMapMode().DPtoLP(20)));

			fFigureCompartmentWhileExpression.add(whileExpressionLabel1);

			fFigureCompartmentWhileStatements = new RoundedRectangle();
			fFigureCompartmentWhileStatements
					.setCornerDimensions(new Dimension(getMapMode().DPtoLP(8),
							getMapMode().DPtoLP(8)));
			fFigureCompartmentWhileStatements
					.setForegroundColor(ColorConstants.black);
			fFigureCompartmentWhileStatements
					.setBackgroundColor(ColorConstants.white);

			fFigureCompartmentWhileStatements
					.setFont(FFIGURECOMPARTMENTWHILESTATEMENTS_FONT);

			this.add(fFigureCompartmentWhileStatements);

			WrappingLabel whileStatementsLabel1 = new WrappingLabel();
			whileStatementsLabel1.setText("THEN");
			whileStatementsLabel1.setForegroundColor(ColorConstants.black);
			whileStatementsLabel1.setBackgroundColor(ColorConstants.yellow);

			whileStatementsLabel1.setFont(WHILESTATEMENTSLABEL1_FONT);

			whileStatementsLabel1.setMaximumSize(new Dimension(getMapMode()
					.DPtoLP(300), getMapMode().DPtoLP(20)));

			fFigureCompartmentWhileStatements.add(whileStatementsLabel1);

		}

		/**
		 * @generated
		 */
		private boolean myUseLocalCoordinates = false;

		/**
		 * @generated
		 */
		protected boolean useLocalCoordinates() {
			return myUseLocalCoordinates;
		}

		/**
		 * @generated
		 */
		protected void setUseLocalCoordinates(boolean useLocalCoordinates) {
			myUseLocalCoordinates = useLocalCoordinates;
		}

		/**
		 * @generated
		 */
		public RectangleFigure getFigureCompartmentWhileExpression() {
			return fFigureCompartmentWhileExpression;
		}

		/**
		 * @generated
		 */
		public RoundedRectangle getFigureCompartmentWhileStatements() {
			return fFigureCompartmentWhileStatements;
		}

	}

	/**
	 * @generated
	 */
	static final Font THIS_FONT = new Font(Display.getCurrent(), Display
			.getDefault().getSystemFont().getFontData()[0].getName(), 7,
			SWT.NORMAL);

	/**
	 * @generated
	 */
	static final Font WHILEEXPRESSIONLABEL1_FONT = new Font(Display
			.getCurrent(),
			Display.getDefault().getSystemFont().getFontData()[0].getName(), 7,
			SWT.BOLD);

	/**
	 * @generated
	 */
	static final Font FFIGURECOMPARTMENTWHILESTATEMENTS_FONT = new Font(Display
			.getCurrent(),
			Display.getDefault().getSystemFont().getFontData()[0].getName(),
			12, SWT.NORMAL);

	/**
	 * @generated
	 */
	static final Font WHILESTATEMENTSLABEL1_FONT = new Font(Display
			.getCurrent(),
			Display.getDefault().getSystemFont().getFontData()[0].getName(), 7,
			SWT.BOLD);

}
