package eu.ipac.ace.gmf.ipacadl.diagram.edit.policies;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.commands.core.commands.DuplicateEObjectsCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;

import eu.ipac.ace.gmf.ipacadl.IpacadlPackage;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.commands.BodyCreateCommand;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.commands.ConstantDeclarationCreateCommand;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.commands.EventHandlerCreateCommand;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.commands.VariableDeclarationCreateCommand;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.commands.VectorDeclarationCreateCommand;
import eu.ipac.ace.gmf.ipacadl.diagram.providers.IpacadlElementTypes;

/**
 * @generated
 */
public class ApplicationItemSemanticEditPolicy extends
		IpacadlBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (IpacadlElementTypes.Body_1001 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(IpacadlPackage.eINSTANCE
						.getApplication_Body());
			}
			return getGEFWrapper(new BodyCreateCommand(req));
		}
		if (IpacadlElementTypes.VectorDeclaration_1002 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(IpacadlPackage.eINSTANCE
						.getApplication_Declarations());
			}
			return getGEFWrapper(new VectorDeclarationCreateCommand(req));
		}
		if (IpacadlElementTypes.VariableDeclaration_1003 == req
				.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(IpacadlPackage.eINSTANCE
						.getApplication_Declarations());
			}
			return getGEFWrapper(new VariableDeclarationCreateCommand(req));
		}
		if (IpacadlElementTypes.ConstantDeclaration_1004 == req
				.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(IpacadlPackage.eINSTANCE
						.getApplication_Declarations());
			}
			return getGEFWrapper(new ConstantDeclarationCreateCommand(req));
		}
		if (IpacadlElementTypes.EventHandler_1005 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(IpacadlPackage.eINSTANCE
						.getApplication_EventHandlers());
			}
			return getGEFWrapper(new EventHandlerCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDuplicateCommand(DuplicateElementsRequest req) {
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) getHost())
				.getEditingDomain();
		return getGEFWrapper(new DuplicateAnythingCommand(editingDomain, req));
	}

	/**
	 * @generated
	 */
	private static class DuplicateAnythingCommand extends
			DuplicateEObjectsCommand {

		/**
		 * @generated
		 */
		public DuplicateAnythingCommand(
				TransactionalEditingDomain editingDomain,
				DuplicateElementsRequest req) {
			super(editingDomain, req.getLabel(), req
					.getElementsToBeDuplicated(), req
					.getAllDuplicatedElementsMap());
		}

	}

}
