package eu.ipac.ace.gmf.ipacadl.diagram.edit.policies;

import java.util.Iterator;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;

import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.FaultStatementCompartmentOnFaultStatementsEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlVisualIDRegistry;

/**
 * @generated
 */
public class FaultStatementItemSemanticEditPolicy extends
		IpacadlBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		CompoundCommand cc = getDestroyEdgesCommand();
		addDestroyChildNodesCommand(cc);
		addDestroyShortcutsCommand(cc);
		cc.add(getGEFWrapper(new DestroyElementCommand(req)));
		return cc.unwrap();
	}

	/**
	 * @generated
	 */
	protected void addDestroyChildNodesCommand(CompoundCommand cmd) {
		View view = (View) getHost().getModel();
		EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
		if (annotation != null) {
			return;
		}
		for (Iterator it = view.getChildren().iterator(); it.hasNext();) {
			Node node = (Node) it.next();
			switch (IpacadlVisualIDRegistry.getVisualID(node)) {
			case FaultStatementCompartmentOnFaultStatementsEditPart.VISUAL_ID:
				for (Iterator cit = node.getChildren().iterator(); cit
						.hasNext();) {
					Node cnode = (Node) cit.next();
					switch (IpacadlVisualIDRegistry.getVisualID(cnode)) {
					case WaitStatement2EditPart.VISUAL_ID:
						cmd.add(getDestroyElementCommand(cnode));
						break;
					case BreakStatement2EditPart.VISUAL_ID:
						cmd.add(getDestroyElementCommand(cnode));
						break;
					case InvokeStatement2EditPart.VISUAL_ID:
						cmd.add(getDestroyElementCommand(cnode));
						break;
					case IterationStatementEditPart.VISUAL_ID:
						cmd.add(getDestroyElementCommand(cnode));
						break;
					case IfStatement4EditPart.VISUAL_ID:
						cmd.add(getDestroyElementCommand(cnode));
						break;
					case AssignmentStatement4EditPart.VISUAL_ID:
						cmd.add(getDestroyElementCommand(cnode));
						break;
					}
				}
				break;
			}
		}
	}

}
