package eu.ipac.ace.gmf.ipacadl.diagram.navigator;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;

import org.eclipse.core.resources.IFile;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.workspace.util.WorkspaceSynchronizer;
import org.eclipse.gmf.runtime.emf.core.GMFEditingDomainFactory;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonContentProvider;

import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.ApplicationEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BodyCompartmentStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BodyEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BooleanLiteral2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BooleanLiteralEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.ConstantDeclarationEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.DoubleLiteral2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.DoubleLiteralEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.EventAssignmentStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.EventHandlerCompartmentEventHandlerStatementsPropertiesEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.EventHandlerEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.Expression2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.Expression3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.ExpressionEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.FaultStatementCompartmentOnFaultStatementsEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.FaultStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfExpression2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfExpression3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfExpression4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfExpression5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfExpression6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfExpressionEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IntegerLiteral2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IntegerLiteralEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement7EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileExpression2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileExpression3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileExpression4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileExpression5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileExpression6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileExpressionEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.StatementConnectionEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.StringLiteral2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.StringLiteralEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.VariableDeclarationEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.VectorDeclarationEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlVisualIDRegistry;
import eu.ipac.ace.gmf.ipacadl.diagram.part.Messages;

/**
 * @generated
 */
public class IpacadlNavigatorContentProvider implements ICommonContentProvider {

	/**
	 * @generated
	 */
	private static final Object[] EMPTY_ARRAY = new Object[0];

	/**
	 * @generated
	 */
	private Viewer myViewer;

	/**
	 * @generated
	 */
	private AdapterFactoryEditingDomain myEditingDomain;

	/**
	 * @generated
	 */
	private WorkspaceSynchronizer myWorkspaceSynchronizer;

	/**
	 * @generated
	 */
	private Runnable myViewerRefreshRunnable;

	/**
	 * @generated
	 */
	public IpacadlNavigatorContentProvider() {
		TransactionalEditingDomain editingDomain = GMFEditingDomainFactory.INSTANCE
				.createEditingDomain();
		myEditingDomain = (AdapterFactoryEditingDomain) editingDomain;
		myEditingDomain.setResourceToReadOnlyMap(new HashMap() {
			public Object get(Object key) {
				if (!containsKey(key)) {
					put(key, Boolean.TRUE);
				}
				return super.get(key);
			}
		});
		myViewerRefreshRunnable = new Runnable() {
			public void run() {
				if (myViewer != null) {
					myViewer.refresh();
				}
			}
		};
		myWorkspaceSynchronizer = new WorkspaceSynchronizer(editingDomain,
				new WorkspaceSynchronizer.Delegate() {
					public void dispose() {
					}

					public boolean handleResourceChanged(final Resource resource) {
						for (Iterator it = myEditingDomain.getResourceSet()
								.getResources().iterator(); it.hasNext();) {
							Resource nextResource = (Resource) it.next();
							nextResource.unload();
						}
						if (myViewer != null) {
							myViewer.getControl().getDisplay().asyncExec(
									myViewerRefreshRunnable);
						}
						return true;
					}

					public boolean handleResourceDeleted(Resource resource) {
						for (Iterator it = myEditingDomain.getResourceSet()
								.getResources().iterator(); it.hasNext();) {
							Resource nextResource = (Resource) it.next();
							nextResource.unload();
						}
						if (myViewer != null) {
							myViewer.getControl().getDisplay().asyncExec(
									myViewerRefreshRunnable);
						}
						return true;
					}

					public boolean handleResourceMoved(Resource resource,
							final URI newURI) {
						for (Iterator it = myEditingDomain.getResourceSet()
								.getResources().iterator(); it.hasNext();) {
							Resource nextResource = (Resource) it.next();
							nextResource.unload();
						}
						if (myViewer != null) {
							myViewer.getControl().getDisplay().asyncExec(
									myViewerRefreshRunnable);
						}
						return true;
					}
				});
	}

	/**
	 * @generated
	 */
	public void dispose() {
		myWorkspaceSynchronizer.dispose();
		myWorkspaceSynchronizer = null;
		myViewerRefreshRunnable = null;
		for (Iterator it = myEditingDomain.getResourceSet().getResources()
				.iterator(); it.hasNext();) {
			Resource resource = (Resource) it.next();
			resource.unload();
		}
		((TransactionalEditingDomain) myEditingDomain).dispose();
		myEditingDomain = null;
	}

	/**
	 * @generated
	 */
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		myViewer = viewer;
	}

	/**
	 * @generated
	 */
	public Object[] getElements(Object inputElement) {
		return getChildren(inputElement);
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof IFile) {
			IFile file = (IFile) parentElement;
			URI fileURI = URI.createPlatformResourceURI(file.getFullPath()
					.toString(), true);
			Resource resource = myEditingDomain.getResourceSet().getResource(
					fileURI, true);
			Collection result = new ArrayList();
			result
					.addAll(createNavigatorItems(selectViewsByType(resource
							.getContents(), ApplicationEditPart.MODEL_ID),
							file, false));
			return result.toArray();
		}

		if (parentElement instanceof IpacadlNavigatorGroup) {
			IpacadlNavigatorGroup group = (IpacadlNavigatorGroup) parentElement;
			return group.getChildren();
		}

		if (parentElement instanceof IpacadlNavigatorItem) {
			IpacadlNavigatorItem navigatorItem = (IpacadlNavigatorItem) parentElement;
			if (navigatorItem.isLeaf() || !isOwnView(navigatorItem.getView())) {
				return EMPTY_ARRAY;
			}
			return getViewChildren(navigatorItem.getView(), parentElement);
		}

		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Object[] getViewChildren(View view, Object parentElement) {
		switch (IpacadlVisualIDRegistry.getVisualID(view)) {

		case ApplicationEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup links = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_Application_79_links,
					"icons/linksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), BodyEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					VectorDeclarationEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					VariableDeclarationEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					ConstantDeclarationEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					EventHandlerEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getDiagramLinksByType(Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			links
					.addChildren(createNavigatorItems(connectedViews, links,
							false));
			if (!links.isEmpty()) {
				result.add(links);
			}
			return result.toArray();
		}

		case BodyEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view),
					BodyCompartmentStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					BodyCompartmentStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					BodyCompartmentStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					BodyCompartmentStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					BodyCompartmentStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					BodyCompartmentStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case VariableDeclarationEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), BooleanLiteralEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					DoubleLiteralEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IntegerLiteralEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					StringLiteralEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case ConstantDeclarationEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), BooleanLiteral2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					DoubleLiteral2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IntegerLiteral2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					StringLiteral2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case EventHandlerEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(
					Collections.singleton(view),
					EventHandlerCompartmentEventHandlerStatementsPropertiesEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					EventAssignmentStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					EventHandlerCompartmentEventHandlerStatementsPropertiesEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement6EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					EventHandlerCompartmentEventHandlerStatementsPropertiesEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement6EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					EventHandlerCompartmentEventHandlerStatementsPropertiesEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement7EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					EventHandlerCompartmentEventHandlerStatementsPropertiesEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement6EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					EventHandlerCompartmentEventHandlerStatementsPropertiesEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatement6EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					EventHandlerCompartmentEventHandlerStatementsPropertiesEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatement6EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case WaitStatementEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_WaitStatement_2001_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_WaitStatement_2001_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case BreakStatementEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_BreakStatement_2002_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_BreakStatement_2002_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case InvokeStatementEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_InvokeStatement_2003_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_InvokeStatement_2003_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), FaultStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case FaultStatementEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			Collection connectedViews = getChildrenByType(
					Collections.singleton(view),
					FaultStatementCompartmentOnFaultStatementsEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					FaultStatementCompartmentOnFaultStatementsEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					FaultStatementCompartmentOnFaultStatementsEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					FaultStatementCompartmentOnFaultStatementsEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					FaultStatementCompartmentOnFaultStatementsEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					FaultStatementCompartmentOnFaultStatementsEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case WaitStatement2EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_WaitStatement_2005_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_WaitStatement_2005_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case BreakStatement2EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_BreakStatement_2006_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_BreakStatement_2006_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case InvokeStatement2EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_InvokeStatement_2007_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_InvokeStatement_2007_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), FaultStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case IterationStatementEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IterationStatement_2008_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IterationStatement_2008_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileExpressionEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					ExpressionEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case WaitStatement3EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_WaitStatement_2010_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_WaitStatement_2010_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case BreakStatement3EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_BreakStatement_2011_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_BreakStatement_2011_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case InvokeStatement3EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_InvokeStatement_2012_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_InvokeStatement_2012_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), FaultStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case IterationStatement2EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IterationStatement_2013_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IterationStatement_2013_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileExpression2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					ExpressionEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case IfStatementEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IfStatement_2014_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IfStatement_2014_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view),
					IfStatementCompartmentIfExpressionEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					Expression2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement6EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatementEditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case WaitStatement4EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_WaitStatement_2016_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_WaitStatement_2016_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case BreakStatement4EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_BreakStatement_2017_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_BreakStatement_2017_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case InvokeStatement4EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_InvokeStatement_2018_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_InvokeStatement_2018_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), FaultStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case IterationStatement3EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IterationStatement_2019_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IterationStatement_2019_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileExpression3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					ExpressionEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case AssignmentStatementEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_AssignmentStatement_2020_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_AssignmentStatement_2020_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), Expression3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					InvokeStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case InvokeStatement5EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_InvokeStatement_2022_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_InvokeStatement_2022_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), FaultStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case IfStatement2EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IfStatement_2023_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IfStatement_2023_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view),
					IfStatementCompartmentIfExpression2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					Expression2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement6EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement2EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case AssignmentStatement2EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_AssignmentStatement_2024_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_AssignmentStatement_2024_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), Expression3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					InvokeStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case WaitStatement5EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_WaitStatement_2025_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_WaitStatement_2025_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case BreakStatement5EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_BreakStatement_2026_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_BreakStatement_2026_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case InvokeStatement6EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_InvokeStatement_2027_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_InvokeStatement_2027_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), FaultStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case IterationStatement4EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IterationStatement_2028_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IterationStatement_2028_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileExpression4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					ExpressionEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case IfStatement3EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IfStatement_2029_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IfStatement_2029_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view),
					IfStatementCompartmentIfExpression3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					Expression2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement6EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement3EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case AssignmentStatement3EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_AssignmentStatement_2030_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_AssignmentStatement_2030_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), Expression3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					InvokeStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case IfStatement4EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IfStatement_2031_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IfStatement_2031_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view),
					IfStatementCompartmentIfExpression4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					Expression2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement6EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement4EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case AssignmentStatement4EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_AssignmentStatement_2032_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_AssignmentStatement_2032_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), Expression3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					InvokeStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case IterationStatement5EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IterationStatement_2033_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IterationStatement_2033_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileExpression5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					ExpressionEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case IfStatement5EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IfStatement_2034_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IfStatement_2034_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view),
					IfStatementCompartmentIfExpression5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					Expression2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement6EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement5EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case AssignmentStatement5EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_AssignmentStatement_2035_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_AssignmentStatement_2035_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), Expression3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					InvokeStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case WaitStatement6EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_WaitStatement_2045_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_WaitStatement_2045_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case BreakStatement6EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_BreakStatement_2046_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_BreakStatement_2046_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getIncomingLinksByType(Collections
					.singleton(view), StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case InvokeStatement7EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_InvokeStatement_2047_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_InvokeStatement_2047_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), FaultStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case IterationStatement6EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IterationStatement_2048_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IterationStatement_2048_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileExpression6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					ExpressionEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(view),
					IterationStatementCompartmentWhileStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatementEditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case IfStatement6EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IfStatement_2049_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_IfStatement_2049_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view),
					IfStatementCompartmentIfExpression6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					Expression2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentIfStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatement2EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					WaitStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					BreakStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					InvokeStatement6EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IterationStatement4EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					IfStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					IfStatementCompartmentElseStatement6EditPart.VISUAL_ID);
			connectedViews = getChildrenByType(connectedViews,
					AssignmentStatement3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case AssignmentStatement6EditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup incominglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_AssignmentStatement_2050_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup outgoinglinks = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_AssignmentStatement_2050_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getChildrenByType(Collections
					.singleton(view), Expression3EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(view),
					InvokeStatement5EditPart.VISUAL_ID);
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(view),
					StatementConnectionEditPart.VISUAL_ID);
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case StatementConnectionEditPart.VISUAL_ID: {
			Collection result = new ArrayList();
			IpacadlNavigatorGroup target = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_StatementConnection_3001_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			IpacadlNavigatorGroup source = new IpacadlNavigatorGroup(
					Messages.NavigatorGroupName_StatementConnection_3001_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection connectedViews = getLinksTargetByType(Collections
					.singleton(view), WaitStatementEditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					BreakStatementEditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					InvokeStatementEditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					WaitStatement2EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					BreakStatement2EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					InvokeStatement2EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					IterationStatementEditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					WaitStatement3EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					BreakStatement3EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					InvokeStatement3EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					IterationStatement2EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					IfStatementEditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					WaitStatement4EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					BreakStatement4EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					InvokeStatement4EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					IterationStatement3EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					AssignmentStatementEditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					InvokeStatement5EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					IfStatement2EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					AssignmentStatement2EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					WaitStatement5EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					BreakStatement5EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					InvokeStatement6EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					IterationStatement4EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					IfStatement3EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					AssignmentStatement3EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					IfStatement4EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					AssignmentStatement4EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					IterationStatement5EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					IfStatement5EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					AssignmentStatement5EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					WaitStatement6EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					BreakStatement6EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					InvokeStatement7EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					IterationStatement6EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					IfStatement6EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(Collections.singleton(view),
					AssignmentStatement6EditPart.VISUAL_ID);
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					WaitStatementEditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					BreakStatementEditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					InvokeStatementEditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					WaitStatement2EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					BreakStatement2EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					InvokeStatement2EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					IterationStatementEditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					WaitStatement3EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					BreakStatement3EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					InvokeStatement3EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					IterationStatement2EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					IfStatementEditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					WaitStatement4EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					BreakStatement4EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					InvokeStatement4EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					IterationStatement3EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					AssignmentStatementEditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					InvokeStatement5EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					IfStatement2EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					AssignmentStatement2EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					WaitStatement5EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					BreakStatement5EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					InvokeStatement6EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					IterationStatement4EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					IfStatement3EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					AssignmentStatement3EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					IfStatement4EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					AssignmentStatement4EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					IterationStatement5EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					IfStatement5EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					AssignmentStatement5EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					WaitStatement6EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					BreakStatement6EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					InvokeStatement7EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					IterationStatement6EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					IfStatement6EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(view),
					AssignmentStatement6EditPart.VISUAL_ID);
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}
		}
		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Collection getLinksSourceByType(Collection edges, int visualID) {
		Collection result = new ArrayList();
		String type = IpacadlVisualIDRegistry.getType(visualID);
		for (Iterator it = edges.iterator(); it.hasNext();) {
			Edge nextEdge = (Edge) it.next();
			View nextEdgeSource = nextEdge.getSource();
			if (type.equals(nextEdgeSource.getType())
					&& isOwnView(nextEdgeSource)) {
				result.add(nextEdgeSource);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection getLinksTargetByType(Collection edges, int visualID) {
		Collection result = new ArrayList();
		String type = IpacadlVisualIDRegistry.getType(visualID);
		for (Iterator it = edges.iterator(); it.hasNext();) {
			Edge nextEdge = (Edge) it.next();
			View nextEdgeTarget = nextEdge.getTarget();
			if (type.equals(nextEdgeTarget.getType())
					&& isOwnView(nextEdgeTarget)) {
				result.add(nextEdgeTarget);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection getOutgoingLinksByType(Collection nodes, int visualID) {
		Collection result = new ArrayList();
		String type = IpacadlVisualIDRegistry.getType(visualID);
		for (Iterator it = nodes.iterator(); it.hasNext();) {
			View nextNode = (View) it.next();
			result.addAll(selectViewsByType(nextNode.getSourceEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection getIncomingLinksByType(Collection nodes, int visualID) {
		Collection result = new ArrayList();
		String type = IpacadlVisualIDRegistry.getType(visualID);
		for (Iterator it = nodes.iterator(); it.hasNext();) {
			View nextNode = (View) it.next();
			result.addAll(selectViewsByType(nextNode.getTargetEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection getChildrenByType(Collection nodes, int visualID) {
		Collection result = new ArrayList();
		String type = IpacadlVisualIDRegistry.getType(visualID);
		for (Iterator it = nodes.iterator(); it.hasNext();) {
			View nextNode = (View) it.next();
			result.addAll(selectViewsByType(nextNode.getChildren(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection getDiagramLinksByType(Collection diagrams, int visualID) {
		Collection result = new ArrayList();
		String type = IpacadlVisualIDRegistry.getType(visualID);
		for (Iterator it = diagrams.iterator(); it.hasNext();) {
			Diagram nextDiagram = (Diagram) it.next();
			result.addAll(selectViewsByType(nextDiagram.getEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection selectViewsByType(Collection views, String type) {
		Collection result = new ArrayList();
		for (Iterator it = views.iterator(); it.hasNext();) {
			View nextView = (View) it.next();
			if (type.equals(nextView.getType()) && isOwnView(nextView)) {
				result.add(nextView);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return ApplicationEditPart.MODEL_ID.equals(IpacadlVisualIDRegistry
				.getModelID(view));
	}

	/**
	 * @generated
	 */
	private Collection createNavigatorItems(Collection views, Object parent,
			boolean isLeafs) {
		Collection result = new ArrayList();
		for (Iterator it = views.iterator(); it.hasNext();) {
			result.add(new IpacadlNavigatorItem((View) it.next(), parent,
					isLeafs));
		}
		return result;
	}

	/**
	 * @generated
	 */
	public Object getParent(Object element) {
		if (element instanceof IpacadlAbstractNavigatorItem) {
			IpacadlAbstractNavigatorItem abstractNavigatorItem = (IpacadlAbstractNavigatorItem) element;
			return abstractNavigatorItem.getParent();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean hasChildren(Object element) {
		return element instanceof IFile || getChildren(element).length > 0;
	}

}
