package eu.ipac.ace.gmf.ipacadl.diagram.navigator;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserService;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

import eu.ipac.ace.gmf.ipacadl.Application;
import eu.ipac.ace.gmf.ipacadl.BooleanLiteral;
import eu.ipac.ace.gmf.ipacadl.DoubleLiteral;
import eu.ipac.ace.gmf.ipacadl.EventHandler;
import eu.ipac.ace.gmf.ipacadl.IntegerLiteral;
import eu.ipac.ace.gmf.ipacadl.StringLiteral;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.ApplicationEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BodyEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BooleanLiteral2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BooleanLiteralEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.ConstantDeclarationEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.ConstantDeclarationNameEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.DoubleLiteral2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.DoubleLiteralEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.EventAssignmentStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.EventAssignmentStatementPropIdEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.EventHandlerEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.EventHandlerNameEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.Expression2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.Expression3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.ExpressionEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.ExpressionStrExpression2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.ExpressionStrExpression3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.ExpressionStrExpressionEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.FaultStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IntegerLiteral2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IntegerLiteralEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement7EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatementComponentName2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatementComponentName3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatementComponentName4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatementComponentName5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatementComponentName6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatementComponentName7EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatementComponentNameEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.StatementConnectionEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.StringLiteral2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.StringLiteralEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.VariableDeclarationEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.VariableDeclarationNameEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.VectorDeclarationEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.VectorDeclarationNameEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatementSecs2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatementSecs3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatementSecs4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatementSecs5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatementSecs6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatementSecsEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlDiagramEditorPlugin;
import eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlVisualIDRegistry;
import eu.ipac.ace.gmf.ipacadl.diagram.providers.IpacadlElementTypes;
import eu.ipac.ace.gmf.ipacadl.diagram.providers.IpacadlParserProvider;

/**
 * @generated
 */
public class IpacadlNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		IpacadlDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put(
						"Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		IpacadlDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put(
						"Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof IpacadlNavigatorItem
				&& !isOwnView(((IpacadlNavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof IpacadlNavigatorGroup) {
			IpacadlNavigatorGroup group = (IpacadlNavigatorGroup) element;
			return IpacadlDiagramEditorPlugin.getInstance().getBundledImage(
					group.getIcon());
		}

		if (element instanceof IpacadlNavigatorItem) {
			IpacadlNavigatorItem navigatorItem = (IpacadlNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (IpacadlVisualIDRegistry.getVisualID(view)) {
		case ApplicationEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?http://ipac.di.uoa.gr/ace/adl?Application", IpacadlElementTypes.Application_79); //$NON-NLS-1$
		case BodyEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://ipac.di.uoa.gr/ace/adl?Body", IpacadlElementTypes.Body_1001); //$NON-NLS-1$
		case VectorDeclarationEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://ipac.di.uoa.gr/ace/adl?VectorDeclaration", IpacadlElementTypes.VectorDeclaration_1002); //$NON-NLS-1$
		case VariableDeclarationEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://ipac.di.uoa.gr/ace/adl?VariableDeclaration", IpacadlElementTypes.VariableDeclaration_1003); //$NON-NLS-1$
		case ConstantDeclarationEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://ipac.di.uoa.gr/ace/adl?ConstantDeclaration", IpacadlElementTypes.ConstantDeclaration_1004); //$NON-NLS-1$
		case EventHandlerEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://ipac.di.uoa.gr/ace/adl?EventHandler", IpacadlElementTypes.EventHandler_1005); //$NON-NLS-1$
		case WaitStatementEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?WaitStatement", IpacadlElementTypes.WaitStatement_2001); //$NON-NLS-1$
		case BreakStatementEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?BreakStatement", IpacadlElementTypes.BreakStatement_2002); //$NON-NLS-1$
		case InvokeStatementEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?InvokeStatement", IpacadlElementTypes.InvokeStatement_2003); //$NON-NLS-1$
		case FaultStatementEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?FaultStatement", IpacadlElementTypes.FaultStatement_2004); //$NON-NLS-1$
		case WaitStatement2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?WaitStatement", IpacadlElementTypes.WaitStatement_2005); //$NON-NLS-1$
		case BreakStatement2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?BreakStatement", IpacadlElementTypes.BreakStatement_2006); //$NON-NLS-1$
		case InvokeStatement2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?InvokeStatement", IpacadlElementTypes.InvokeStatement_2007); //$NON-NLS-1$
		case IterationStatementEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?IterationStatement", IpacadlElementTypes.IterationStatement_2008); //$NON-NLS-1$
		case ExpressionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?Expression", IpacadlElementTypes.Expression_2009); //$NON-NLS-1$
		case WaitStatement3EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?WaitStatement", IpacadlElementTypes.WaitStatement_2010); //$NON-NLS-1$
		case BreakStatement3EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?BreakStatement", IpacadlElementTypes.BreakStatement_2011); //$NON-NLS-1$
		case InvokeStatement3EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?InvokeStatement", IpacadlElementTypes.InvokeStatement_2012); //$NON-NLS-1$
		case IterationStatement2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?IterationStatement", IpacadlElementTypes.IterationStatement_2013); //$NON-NLS-1$
		case IfStatementEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?IfStatement", IpacadlElementTypes.IfStatement_2014); //$NON-NLS-1$
		case Expression2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?Expression", IpacadlElementTypes.Expression_2015); //$NON-NLS-1$
		case WaitStatement4EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?WaitStatement", IpacadlElementTypes.WaitStatement_2016); //$NON-NLS-1$
		case BreakStatement4EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?BreakStatement", IpacadlElementTypes.BreakStatement_2017); //$NON-NLS-1$
		case InvokeStatement4EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?InvokeStatement", IpacadlElementTypes.InvokeStatement_2018); //$NON-NLS-1$
		case IterationStatement3EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?IterationStatement", IpacadlElementTypes.IterationStatement_2019); //$NON-NLS-1$
		case AssignmentStatementEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?AssignmentStatement", IpacadlElementTypes.AssignmentStatement_2020); //$NON-NLS-1$
		case Expression3EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?Expression", IpacadlElementTypes.Expression_2021); //$NON-NLS-1$
		case InvokeStatement5EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?InvokeStatement", IpacadlElementTypes.InvokeStatement_2022); //$NON-NLS-1$
		case IfStatement2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?IfStatement", IpacadlElementTypes.IfStatement_2023); //$NON-NLS-1$
		case AssignmentStatement2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?AssignmentStatement", IpacadlElementTypes.AssignmentStatement_2024); //$NON-NLS-1$
		case WaitStatement5EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?WaitStatement", IpacadlElementTypes.WaitStatement_2025); //$NON-NLS-1$
		case BreakStatement5EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?BreakStatement", IpacadlElementTypes.BreakStatement_2026); //$NON-NLS-1$
		case InvokeStatement6EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?InvokeStatement", IpacadlElementTypes.InvokeStatement_2027); //$NON-NLS-1$
		case IterationStatement4EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?IterationStatement", IpacadlElementTypes.IterationStatement_2028); //$NON-NLS-1$
		case IfStatement3EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?IfStatement", IpacadlElementTypes.IfStatement_2029); //$NON-NLS-1$
		case AssignmentStatement3EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?AssignmentStatement", IpacadlElementTypes.AssignmentStatement_2030); //$NON-NLS-1$
		case IfStatement4EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?IfStatement", IpacadlElementTypes.IfStatement_2031); //$NON-NLS-1$
		case AssignmentStatement4EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?AssignmentStatement", IpacadlElementTypes.AssignmentStatement_2032); //$NON-NLS-1$
		case IterationStatement5EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?IterationStatement", IpacadlElementTypes.IterationStatement_2033); //$NON-NLS-1$
		case IfStatement5EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?IfStatement", IpacadlElementTypes.IfStatement_2034); //$NON-NLS-1$
		case AssignmentStatement5EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?AssignmentStatement", IpacadlElementTypes.AssignmentStatement_2035); //$NON-NLS-1$
		case BooleanLiteralEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?BooleanLiteral", IpacadlElementTypes.BooleanLiteral_2036); //$NON-NLS-1$
		case DoubleLiteralEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?DoubleLiteral", IpacadlElementTypes.DoubleLiteral_2037); //$NON-NLS-1$
		case IntegerLiteralEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?IntegerLiteral", IpacadlElementTypes.IntegerLiteral_2038); //$NON-NLS-1$
		case StringLiteralEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?StringLiteral", IpacadlElementTypes.StringLiteral_2039); //$NON-NLS-1$
		case BooleanLiteral2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?BooleanLiteral", IpacadlElementTypes.BooleanLiteral_2040); //$NON-NLS-1$
		case DoubleLiteral2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?DoubleLiteral", IpacadlElementTypes.DoubleLiteral_2041); //$NON-NLS-1$
		case IntegerLiteral2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?IntegerLiteral", IpacadlElementTypes.IntegerLiteral_2042); //$NON-NLS-1$
		case StringLiteral2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?StringLiteral", IpacadlElementTypes.StringLiteral_2043); //$NON-NLS-1$
		case EventAssignmentStatementEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?EventAssignmentStatement", IpacadlElementTypes.EventAssignmentStatement_2044); //$NON-NLS-1$
		case WaitStatement6EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?WaitStatement", IpacadlElementTypes.WaitStatement_2045); //$NON-NLS-1$
		case BreakStatement6EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?BreakStatement", IpacadlElementTypes.BreakStatement_2046); //$NON-NLS-1$
		case InvokeStatement7EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?InvokeStatement", IpacadlElementTypes.InvokeStatement_2047); //$NON-NLS-1$
		case IterationStatement6EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?IterationStatement", IpacadlElementTypes.IterationStatement_2048); //$NON-NLS-1$
		case IfStatement6EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?IfStatement", IpacadlElementTypes.IfStatement_2049); //$NON-NLS-1$
		case AssignmentStatement6EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://ipac.di.uoa.gr/ace/adl?AssignmentStatement", IpacadlElementTypes.AssignmentStatement_2050); //$NON-NLS-1$
		case StatementConnectionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://ipac.di.uoa.gr/ace/adl?Statement?Connection", IpacadlElementTypes.StatementConnection_3001); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = IpacadlDiagramEditorPlugin.getInstance()
				.getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null
				&& IpacadlElementTypes.isKnownElementType(elementType)) {
			image = IpacadlElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof IpacadlNavigatorGroup) {
			IpacadlNavigatorGroup group = (IpacadlNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof IpacadlNavigatorItem) {
			IpacadlNavigatorItem navigatorItem = (IpacadlNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (IpacadlVisualIDRegistry.getVisualID(view)) {
		case ApplicationEditPart.VISUAL_ID:
			return getApplication_79Text(view);
		case BodyEditPart.VISUAL_ID:
			return getBody_1001Text(view);
		case VectorDeclarationEditPart.VISUAL_ID:
			return getVectorDeclaration_1002Text(view);
		case VariableDeclarationEditPart.VISUAL_ID:
			return getVariableDeclaration_1003Text(view);
		case ConstantDeclarationEditPart.VISUAL_ID:
			return getConstantDeclaration_1004Text(view);
		case EventHandlerEditPart.VISUAL_ID:
			return getEventHandler_1005Text(view);
		case WaitStatementEditPart.VISUAL_ID:
			return getWaitStatement_2001Text(view);
		case BreakStatementEditPart.VISUAL_ID:
			return getBreakStatement_2002Text(view);
		case InvokeStatementEditPart.VISUAL_ID:
			return getInvokeStatement_2003Text(view);
		case FaultStatementEditPart.VISUAL_ID:
			return getFaultStatement_2004Text(view);
		case WaitStatement2EditPart.VISUAL_ID:
			return getWaitStatement_2005Text(view);
		case BreakStatement2EditPart.VISUAL_ID:
			return getBreakStatement_2006Text(view);
		case InvokeStatement2EditPart.VISUAL_ID:
			return getInvokeStatement_2007Text(view);
		case IterationStatementEditPart.VISUAL_ID:
			return getIterationStatement_2008Text(view);
		case ExpressionEditPart.VISUAL_ID:
			return getExpression_2009Text(view);
		case WaitStatement3EditPart.VISUAL_ID:
			return getWaitStatement_2010Text(view);
		case BreakStatement3EditPart.VISUAL_ID:
			return getBreakStatement_2011Text(view);
		case InvokeStatement3EditPart.VISUAL_ID:
			return getInvokeStatement_2012Text(view);
		case IterationStatement2EditPart.VISUAL_ID:
			return getIterationStatement_2013Text(view);
		case IfStatementEditPart.VISUAL_ID:
			return getIfStatement_2014Text(view);
		case Expression2EditPart.VISUAL_ID:
			return getExpression_2015Text(view);
		case WaitStatement4EditPart.VISUAL_ID:
			return getWaitStatement_2016Text(view);
		case BreakStatement4EditPart.VISUAL_ID:
			return getBreakStatement_2017Text(view);
		case InvokeStatement4EditPart.VISUAL_ID:
			return getInvokeStatement_2018Text(view);
		case IterationStatement3EditPart.VISUAL_ID:
			return getIterationStatement_2019Text(view);
		case AssignmentStatementEditPart.VISUAL_ID:
			return getAssignmentStatement_2020Text(view);
		case Expression3EditPart.VISUAL_ID:
			return getExpression_2021Text(view);
		case InvokeStatement5EditPart.VISUAL_ID:
			return getInvokeStatement_2022Text(view);
		case IfStatement2EditPart.VISUAL_ID:
			return getIfStatement_2023Text(view);
		case AssignmentStatement2EditPart.VISUAL_ID:
			return getAssignmentStatement_2024Text(view);
		case WaitStatement5EditPart.VISUAL_ID:
			return getWaitStatement_2025Text(view);
		case BreakStatement5EditPart.VISUAL_ID:
			return getBreakStatement_2026Text(view);
		case InvokeStatement6EditPart.VISUAL_ID:
			return getInvokeStatement_2027Text(view);
		case IterationStatement4EditPart.VISUAL_ID:
			return getIterationStatement_2028Text(view);
		case IfStatement3EditPart.VISUAL_ID:
			return getIfStatement_2029Text(view);
		case AssignmentStatement3EditPart.VISUAL_ID:
			return getAssignmentStatement_2030Text(view);
		case IfStatement4EditPart.VISUAL_ID:
			return getIfStatement_2031Text(view);
		case AssignmentStatement4EditPart.VISUAL_ID:
			return getAssignmentStatement_2032Text(view);
		case IterationStatement5EditPart.VISUAL_ID:
			return getIterationStatement_2033Text(view);
		case IfStatement5EditPart.VISUAL_ID:
			return getIfStatement_2034Text(view);
		case AssignmentStatement5EditPart.VISUAL_ID:
			return getAssignmentStatement_2035Text(view);
		case BooleanLiteralEditPart.VISUAL_ID:
			return getBooleanLiteral_2036Text(view);
		case DoubleLiteralEditPart.VISUAL_ID:
			return getDoubleLiteral_2037Text(view);
		case IntegerLiteralEditPart.VISUAL_ID:
			return getIntegerLiteral_2038Text(view);
		case StringLiteralEditPart.VISUAL_ID:
			return getStringLiteral_2039Text(view);
		case BooleanLiteral2EditPart.VISUAL_ID:
			return getBooleanLiteral_2040Text(view);
		case DoubleLiteral2EditPart.VISUAL_ID:
			return getDoubleLiteral_2041Text(view);
		case IntegerLiteral2EditPart.VISUAL_ID:
			return getIntegerLiteral_2042Text(view);
		case StringLiteral2EditPart.VISUAL_ID:
			return getStringLiteral_2043Text(view);
		case EventAssignmentStatementEditPart.VISUAL_ID:
			return getEventAssignmentStatement_2044Text(view);
		case WaitStatement6EditPart.VISUAL_ID:
			return getWaitStatement_2045Text(view);
		case BreakStatement6EditPart.VISUAL_ID:
			return getBreakStatement_2046Text(view);
		case InvokeStatement7EditPart.VISUAL_ID:
			return getInvokeStatement_2047Text(view);
		case IterationStatement6EditPart.VISUAL_ID:
			return getIterationStatement_2048Text(view);
		case IfStatement6EditPart.VISUAL_ID:
			return getIfStatement_2049Text(view);
		case AssignmentStatement6EditPart.VISUAL_ID:
			return getAssignmentStatement_2050Text(view);
		case StatementConnectionEditPart.VISUAL_ID:
			return getStatementConnection_3001Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getApplication_79Text(View view) {
		Application domainModelElement = (Application) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getAppName();
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 79); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getBody_1001Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getVectorDeclaration_1002Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.VectorDeclaration_1002,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(VectorDeclarationNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4021); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getVariableDeclaration_1003Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.VariableDeclaration_1003, (view
						.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(VariableDeclarationNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4022); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getConstantDeclaration_1004Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.ConstantDeclaration_1004, (view
						.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(ConstantDeclarationNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4023); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getEventHandler_1005Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.EventHandler_1005,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(EventHandlerNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4028); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getWaitStatement_2001Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.WaitStatement_2001,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(WaitStatementSecsEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getBreakStatement_2002Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getInvokeStatement_2003Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.InvokeStatement_2003,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(InvokeStatementComponentNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4019); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getFaultStatement_2004Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getWaitStatement_2005Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.WaitStatement_2005,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(WaitStatementSecs2EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getBreakStatement_2006Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getInvokeStatement_2007Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.InvokeStatement_2007,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(InvokeStatementComponentName2EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getIterationStatement_2008Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getExpression_2009Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.Expression_2009,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(ExpressionStrExpressionEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getWaitStatement_2010Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.WaitStatement_2010,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(WaitStatementSecs3EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4006); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getBreakStatement_2011Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getInvokeStatement_2012Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.InvokeStatement_2012,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(InvokeStatementComponentName3EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4007); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getIterationStatement_2013Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getIfStatement_2014Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getExpression_2015Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.Expression_2015,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(ExpressionStrExpression2EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4009); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getWaitStatement_2016Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.WaitStatement_2016,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(WaitStatementSecs4EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4010); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getBreakStatement_2017Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getInvokeStatement_2018Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.InvokeStatement_2018,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(InvokeStatementComponentName4EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4011); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getIterationStatement_2019Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getAssignmentStatement_2020Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getExpression_2021Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.Expression_2021,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(ExpressionStrExpression3EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4013); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getInvokeStatement_2022Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.InvokeStatement_2022,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(InvokeStatementComponentName5EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4014); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getIfStatement_2023Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getAssignmentStatement_2024Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getWaitStatement_2025Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.WaitStatement_2025,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(WaitStatementSecs5EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4016); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getBreakStatement_2026Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getInvokeStatement_2027Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.InvokeStatement_2027,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(InvokeStatementComponentName6EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4017); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getIterationStatement_2028Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getIfStatement_2029Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getAssignmentStatement_2030Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getIfStatement_2031Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getAssignmentStatement_2032Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getIterationStatement_2033Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getIfStatement_2034Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getAssignmentStatement_2035Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getBooleanLiteral_2036Text(View view) {
		BooleanLiteral domainModelElement = (BooleanLiteral) view.getElement();
		if (domainModelElement != null) {
			return String.valueOf(domainModelElement.getBooleanValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 2036); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getDoubleLiteral_2037Text(View view) {
		DoubleLiteral domainModelElement = (DoubleLiteral) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getDoubleValue();
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 2037); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getIntegerLiteral_2038Text(View view) {
		IntegerLiteral domainModelElement = (IntegerLiteral) view.getElement();
		if (domainModelElement != null) {
			return String.valueOf(domainModelElement.getIntValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 2038); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getStringLiteral_2039Text(View view) {
		StringLiteral domainModelElement = (StringLiteral) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getStrValue();
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 2039); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getBooleanLiteral_2040Text(View view) {
		BooleanLiteral domainModelElement = (BooleanLiteral) view.getElement();
		if (domainModelElement != null) {
			return String.valueOf(domainModelElement.getBooleanValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 2040); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getDoubleLiteral_2041Text(View view) {
		DoubleLiteral domainModelElement = (DoubleLiteral) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getDoubleValue();
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 2041); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getIntegerLiteral_2042Text(View view) {
		IntegerLiteral domainModelElement = (IntegerLiteral) view.getElement();
		if (domainModelElement != null) {
			return String.valueOf(domainModelElement.getIntValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 2042); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getStringLiteral_2043Text(View view) {
		StringLiteral domainModelElement = (StringLiteral) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getStrValue();
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 2043); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getEventAssignmentStatement_2044Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.EventAssignmentStatement_2044,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(EventAssignmentStatementPropIdEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4024); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getWaitStatement_2045Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.WaitStatement_2045,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(WaitStatementSecs6EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4025); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getBreakStatement_2046Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getInvokeStatement_2047Text(View view) {
		IAdaptable hintAdapter = new IpacadlParserProvider.HintAdapter(
				IpacadlElementTypes.InvokeStatement_2047,
				(view.getElement() != null ? view.getElement() : view),
				IpacadlVisualIDRegistry
						.getType(InvokeStatementComponentName7EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			IpacadlDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4026); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getIterationStatement_2048Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getIfStatement_2049Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getAssignmentStatement_2050Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getStatementConnection_3001Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$ //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$ //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return ApplicationEditPart.MODEL_ID.equals(IpacadlVisualIDRegistry
				.getModelID(view));
	}

}
