package eu.ipac.ace.gmf.ipacadl.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import java.util.Map;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;

import eu.ipac.ace.gmf.ipacadl.Application;
import eu.ipac.ace.gmf.ipacadl.AssignmentStatement;
import eu.ipac.ace.gmf.ipacadl.Body;
import eu.ipac.ace.gmf.ipacadl.BreakStatement;
import eu.ipac.ace.gmf.ipacadl.ConstantDeclaration;
import eu.ipac.ace.gmf.ipacadl.ConstantValue;
import eu.ipac.ace.gmf.ipacadl.Declaration;
import eu.ipac.ace.gmf.ipacadl.EventAssignmentStatement;
import eu.ipac.ace.gmf.ipacadl.EventHandler;
import eu.ipac.ace.gmf.ipacadl.Expression;
import eu.ipac.ace.gmf.ipacadl.FaultStatement;
import eu.ipac.ace.gmf.ipacadl.IfStatement;
import eu.ipac.ace.gmf.ipacadl.InvokeStatement;
import eu.ipac.ace.gmf.ipacadl.IpacadlPackage;
import eu.ipac.ace.gmf.ipacadl.IterationStatement;
import eu.ipac.ace.gmf.ipacadl.Statement;
import eu.ipac.ace.gmf.ipacadl.VariableDeclaration;
import eu.ipac.ace.gmf.ipacadl.WaitStatement;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.ApplicationEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BodyCompartmentStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BodyEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BooleanLiteral2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BooleanLiteralEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BreakStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.ConstantDeclarationEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.DoubleLiteral2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.DoubleLiteralEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.EventAssignmentStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.EventHandlerCompartmentEventHandlerStatementsPropertiesEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.EventHandlerEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.Expression2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.Expression3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.ExpressionEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.FaultStatementCompartmentOnFaultStatementsEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.FaultStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfExpression2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfExpression3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfExpression4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfExpression5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfExpression6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfExpressionEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IntegerLiteral2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IntegerLiteralEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement7EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileExpression2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileExpression3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileExpression4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileExpression5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileExpression6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileExpressionEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.StatementConnectionEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.StringLiteral2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.StringLiteralEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.VariableDeclarationEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.VectorDeclarationEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.WaitStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.providers.IpacadlElementTypes;

/**
 * @generated
 */
public class IpacadlDiagramUpdater {

	/**
	 * @generated
	 */
	public static List getSemanticChildren(View view) {
		switch (IpacadlVisualIDRegistry.getVisualID(view)) {
		case VariableDeclarationEditPart.VISUAL_ID:
			return getVariableDeclaration_1003SemanticChildren(view);
		case ConstantDeclarationEditPart.VISUAL_ID:
			return getConstantDeclaration_1004SemanticChildren(view);
		case InvokeStatementEditPart.VISUAL_ID:
			return getInvokeStatement_2003SemanticChildren(view);
		case InvokeStatement2EditPart.VISUAL_ID:
			return getInvokeStatement_2007SemanticChildren(view);
		case InvokeStatement3EditPart.VISUAL_ID:
			return getInvokeStatement_2012SemanticChildren(view);
		case InvokeStatement4EditPart.VISUAL_ID:
			return getInvokeStatement_2018SemanticChildren(view);
		case AssignmentStatementEditPart.VISUAL_ID:
			return getAssignmentStatement_2020SemanticChildren(view);
		case InvokeStatement5EditPart.VISUAL_ID:
			return getInvokeStatement_2022SemanticChildren(view);
		case AssignmentStatement2EditPart.VISUAL_ID:
			return getAssignmentStatement_2024SemanticChildren(view);
		case InvokeStatement6EditPart.VISUAL_ID:
			return getInvokeStatement_2027SemanticChildren(view);
		case AssignmentStatement3EditPart.VISUAL_ID:
			return getAssignmentStatement_2030SemanticChildren(view);
		case AssignmentStatement4EditPart.VISUAL_ID:
			return getAssignmentStatement_2032SemanticChildren(view);
		case AssignmentStatement5EditPart.VISUAL_ID:
			return getAssignmentStatement_2035SemanticChildren(view);
		case InvokeStatement7EditPart.VISUAL_ID:
			return getInvokeStatement_2047SemanticChildren(view);
		case AssignmentStatement6EditPart.VISUAL_ID:
			return getAssignmentStatement_2050SemanticChildren(view);
		case BodyCompartmentStatementEditPart.VISUAL_ID:
			return getBodyCompartmentStatement_5001SemanticChildren(view);
		case FaultStatementCompartmentOnFaultStatementsEditPart.VISUAL_ID:
			return getFaultStatementCompartmentOnFaultStatements_5002SemanticChildren(view);
		case IterationStatementCompartmentWhileExpressionEditPart.VISUAL_ID:
			return getIterationStatementCompartmentWhileExpression_5003SemanticChildren(view);
		case IterationStatementCompartmentWhileStatementEditPart.VISUAL_ID:
			return getIterationStatementCompartmentWhileStatement_5004SemanticChildren(view);
		case IterationStatementCompartmentWhileExpression2EditPart.VISUAL_ID:
			return getIterationStatementCompartmentWhileExpression_5005SemanticChildren(view);
		case IterationStatementCompartmentWhileStatement2EditPart.VISUAL_ID:
			return getIterationStatementCompartmentWhileStatement_5006SemanticChildren(view);
		case IfStatementCompartmentIfExpressionEditPart.VISUAL_ID:
			return getIfStatementCompartmentIfExpression_5007SemanticChildren(view);
		case IfStatementCompartmentIfStatementEditPart.VISUAL_ID:
			return getIfStatementCompartmentIfStatement_5008SemanticChildren(view);
		case IfStatementCompartmentElseStatementEditPart.VISUAL_ID:
			return getIfStatementCompartmentElseStatement_5009SemanticChildren(view);
		case IterationStatementCompartmentWhileExpression3EditPart.VISUAL_ID:
			return getIterationStatementCompartmentWhileExpression_5010SemanticChildren(view);
		case IterationStatementCompartmentWhileStatement3EditPart.VISUAL_ID:
			return getIterationStatementCompartmentWhileStatement_5011SemanticChildren(view);
		case IfStatementCompartmentIfExpression2EditPart.VISUAL_ID:
			return getIfStatementCompartmentIfExpression_5012SemanticChildren(view);
		case IfStatementCompartmentIfStatement2EditPart.VISUAL_ID:
			return getIfStatementCompartmentIfStatement_5013SemanticChildren(view);
		case IfStatementCompartmentElseStatement2EditPart.VISUAL_ID:
			return getIfStatementCompartmentElseStatement_5014SemanticChildren(view);
		case IterationStatementCompartmentWhileExpression4EditPart.VISUAL_ID:
			return getIterationStatementCompartmentWhileExpression_5015SemanticChildren(view);
		case IterationStatementCompartmentWhileStatement4EditPart.VISUAL_ID:
			return getIterationStatementCompartmentWhileStatement_5016SemanticChildren(view);
		case IfStatementCompartmentIfExpression3EditPart.VISUAL_ID:
			return getIfStatementCompartmentIfExpression_5017SemanticChildren(view);
		case IfStatementCompartmentIfStatement3EditPart.VISUAL_ID:
			return getIfStatementCompartmentIfStatement_5018SemanticChildren(view);
		case IfStatementCompartmentElseStatement3EditPart.VISUAL_ID:
			return getIfStatementCompartmentElseStatement_5019SemanticChildren(view);
		case IfStatementCompartmentIfExpression4EditPart.VISUAL_ID:
			return getIfStatementCompartmentIfExpression_5020SemanticChildren(view);
		case IfStatementCompartmentIfStatement4EditPart.VISUAL_ID:
			return getIfStatementCompartmentIfStatement_5021SemanticChildren(view);
		case IfStatementCompartmentElseStatement4EditPart.VISUAL_ID:
			return getIfStatementCompartmentElseStatement_5022SemanticChildren(view);
		case IterationStatementCompartmentWhileExpression5EditPart.VISUAL_ID:
			return getIterationStatementCompartmentWhileExpression_5023SemanticChildren(view);
		case IterationStatementCompartmentWhileStatement5EditPart.VISUAL_ID:
			return getIterationStatementCompartmentWhileStatement_5024SemanticChildren(view);
		case IfStatementCompartmentIfExpression5EditPart.VISUAL_ID:
			return getIfStatementCompartmentIfExpression_5025SemanticChildren(view);
		case IfStatementCompartmentIfStatement5EditPart.VISUAL_ID:
			return getIfStatementCompartmentIfStatement_5026SemanticChildren(view);
		case IfStatementCompartmentElseStatement5EditPart.VISUAL_ID:
			return getIfStatementCompartmentElseStatement_5027SemanticChildren(view);
		case EventHandlerCompartmentEventHandlerStatementsPropertiesEditPart.VISUAL_ID:
			return getEventHandlerCompartmentEventHandlerStatementsProperties_5028SemanticChildren(view);
		case IterationStatementCompartmentWhileExpression6EditPart.VISUAL_ID:
			return getIterationStatementCompartmentWhileExpression_5029SemanticChildren(view);
		case IterationStatementCompartmentWhileStatement6EditPart.VISUAL_ID:
			return getIterationStatementCompartmentWhileStatement_5030SemanticChildren(view);
		case IfStatementCompartmentIfExpression6EditPart.VISUAL_ID:
			return getIfStatementCompartmentIfExpression_5031SemanticChildren(view);
		case IfStatementCompartmentIfStatement6EditPart.VISUAL_ID:
			return getIfStatementCompartmentIfStatement_5032SemanticChildren(view);
		case IfStatementCompartmentElseStatement6EditPart.VISUAL_ID:
			return getIfStatementCompartmentElseStatement_5033SemanticChildren(view);
		case ApplicationEditPart.VISUAL_ID:
			return getApplication_79SemanticChildren(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getVariableDeclaration_1003SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		VariableDeclaration modelElement = (VariableDeclaration) view
				.getElement();
		List result = new LinkedList();
		{
			ConstantValue childElement = modelElement.getCValue();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == BooleanLiteralEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
			if (visualID == DoubleLiteralEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
			if (visualID == IntegerLiteralEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
			if (visualID == StringLiteralEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getConstantDeclaration_1004SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		ConstantDeclaration modelElement = (ConstantDeclaration) view
				.getElement();
		List result = new LinkedList();
		{
			ConstantValue childElement = modelElement.getCValue();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == BooleanLiteral2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
			if (visualID == DoubleLiteral2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
			if (visualID == IntegerLiteral2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
			if (visualID == StringLiteral2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2003SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		{
			FaultStatement childElement = modelElement.getFaultStatement();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == FaultStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2007SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		{
			FaultStatement childElement = modelElement.getFaultStatement();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == FaultStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2012SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		{
			FaultStatement childElement = modelElement.getFaultStatement();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == FaultStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2018SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		{
			FaultStatement childElement = modelElement.getFaultStatement();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == FaultStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2020SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Expression3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		{
			InvokeStatement childElement = modelElement.getInvokeStatement();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == InvokeStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2022SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		{
			FaultStatement childElement = modelElement.getFaultStatement();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == FaultStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2024SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Expression3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		{
			InvokeStatement childElement = modelElement.getInvokeStatement();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == InvokeStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2027SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		{
			FaultStatement childElement = modelElement.getFaultStatement();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == FaultStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2030SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Expression3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		{
			InvokeStatement childElement = modelElement.getInvokeStatement();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == InvokeStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2032SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Expression3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		{
			InvokeStatement childElement = modelElement.getInvokeStatement();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == InvokeStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2035SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Expression3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		{
			InvokeStatement childElement = modelElement.getInvokeStatement();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == InvokeStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2047SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		{
			FaultStatement childElement = modelElement.getFaultStatement();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == FaultStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2050SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Expression3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		{
			InvokeStatement childElement = modelElement.getInvokeStatement();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == InvokeStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBodyCompartmentStatement_5001SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		Body modelElement = (Body) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getFaultStatementCompartmentOnFaultStatements_5002SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		FaultStatement modelElement = (FaultStatement) containerView
				.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getFStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatementCompartmentWhileExpression_5003SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IterationStatement modelElement = (IterationStatement) containerView
				.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getWhileExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ExpressionEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatementCompartmentWhileStatement_5004SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IterationStatement modelElement = (IterationStatement) containerView
				.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getWhileStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatementCompartmentWhileExpression_5005SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IterationStatement modelElement = (IterationStatement) containerView
				.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getWhileExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ExpressionEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatementCompartmentWhileStatement_5006SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IterationStatement modelElement = (IterationStatement) containerView
				.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getWhileStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentIfExpression_5007SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getIfExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Expression2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentIfStatement_5008SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getIfStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentElseStatement_5009SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getElseStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement6EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatementCompartmentWhileExpression_5010SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IterationStatement modelElement = (IterationStatement) containerView
				.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getWhileExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ExpressionEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatementCompartmentWhileStatement_5011SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IterationStatement modelElement = (IterationStatement) containerView
				.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getWhileStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentIfExpression_5012SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getIfExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Expression2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentIfStatement_5013SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getIfStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentElseStatement_5014SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getElseStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement6EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatementCompartmentWhileExpression_5015SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IterationStatement modelElement = (IterationStatement) containerView
				.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getWhileExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ExpressionEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatementCompartmentWhileStatement_5016SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IterationStatement modelElement = (IterationStatement) containerView
				.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getWhileStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentIfExpression_5017SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getIfExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Expression2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentIfStatement_5018SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getIfStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentElseStatement_5019SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getElseStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement6EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentIfExpression_5020SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getIfExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Expression2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentIfStatement_5021SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getIfStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentElseStatement_5022SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getElseStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement6EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatementCompartmentWhileExpression_5023SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IterationStatement modelElement = (IterationStatement) containerView
				.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getWhileExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ExpressionEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatementCompartmentWhileStatement_5024SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IterationStatement modelElement = (IterationStatement) containerView
				.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getWhileStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentIfExpression_5025SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getIfExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Expression2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentIfStatement_5026SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getIfStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentElseStatement_5027SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getElseStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement6EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getEventHandlerCompartmentEventHandlerStatementsProperties_5028SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		EventHandler modelElement = (EventHandler) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getEventAssignments().iterator(); it
				.hasNext();) {
			EventAssignmentStatement childElement = (EventAssignmentStatement) it
					.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == EventAssignmentStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getEventStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement6EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement6EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement7EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement6EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatement6EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatement6EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatementCompartmentWhileExpression_5029SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IterationStatement modelElement = (IterationStatement) containerView
				.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getWhileExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ExpressionEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatementCompartmentWhileStatement_5030SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IterationStatement modelElement = (IterationStatement) containerView
				.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getWhileStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatementEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentIfExpression_5031SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		{
			Expression childElement = modelElement.getIfExpression();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Expression2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentIfStatement_5032SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getIfStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatement2EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatementCompartmentElseStatement_5033SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		IfStatement modelElement = (IfStatement) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getElseStatements().iterator(); it
				.hasNext();) {
			Statement childElement = (Statement) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WaitStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == BreakStatement5EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InvokeStatement6EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IterationStatement4EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IfStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AssignmentStatement3EditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getApplication_79SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		Application modelElement = (Application) view.getElement();
		List result = new LinkedList();
		{
			Body childElement = modelElement.getBody();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == BodyEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
			}
		}
		for (Iterator it = modelElement.getDeclarations().iterator(); it
				.hasNext();) {
			Declaration childElement = (Declaration) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == VectorDeclarationEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == VariableDeclarationEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ConstantDeclarationEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getEventHandlers().iterator(); it
				.hasNext();) {
			EventHandler childElement = (EventHandler) it.next();
			int visualID = IpacadlVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == EventHandlerEditPart.VISUAL_ID) {
				result.add(new IpacadlNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getContainedLinks(View view) {
		switch (IpacadlVisualIDRegistry.getVisualID(view)) {
		case ApplicationEditPart.VISUAL_ID:
			return getApplication_79ContainedLinks(view);
		case BodyEditPart.VISUAL_ID:
			return getBody_1001ContainedLinks(view);
		case VectorDeclarationEditPart.VISUAL_ID:
			return getVectorDeclaration_1002ContainedLinks(view);
		case VariableDeclarationEditPart.VISUAL_ID:
			return getVariableDeclaration_1003ContainedLinks(view);
		case ConstantDeclarationEditPart.VISUAL_ID:
			return getConstantDeclaration_1004ContainedLinks(view);
		case EventHandlerEditPart.VISUAL_ID:
			return getEventHandler_1005ContainedLinks(view);
		case WaitStatementEditPart.VISUAL_ID:
			return getWaitStatement_2001ContainedLinks(view);
		case BreakStatementEditPart.VISUAL_ID:
			return getBreakStatement_2002ContainedLinks(view);
		case InvokeStatementEditPart.VISUAL_ID:
			return getInvokeStatement_2003ContainedLinks(view);
		case FaultStatementEditPart.VISUAL_ID:
			return getFaultStatement_2004ContainedLinks(view);
		case WaitStatement2EditPart.VISUAL_ID:
			return getWaitStatement_2005ContainedLinks(view);
		case BreakStatement2EditPart.VISUAL_ID:
			return getBreakStatement_2006ContainedLinks(view);
		case InvokeStatement2EditPart.VISUAL_ID:
			return getInvokeStatement_2007ContainedLinks(view);
		case IterationStatementEditPart.VISUAL_ID:
			return getIterationStatement_2008ContainedLinks(view);
		case ExpressionEditPart.VISUAL_ID:
			return getExpression_2009ContainedLinks(view);
		case WaitStatement3EditPart.VISUAL_ID:
			return getWaitStatement_2010ContainedLinks(view);
		case BreakStatement3EditPart.VISUAL_ID:
			return getBreakStatement_2011ContainedLinks(view);
		case InvokeStatement3EditPart.VISUAL_ID:
			return getInvokeStatement_2012ContainedLinks(view);
		case IterationStatement2EditPart.VISUAL_ID:
			return getIterationStatement_2013ContainedLinks(view);
		case IfStatementEditPart.VISUAL_ID:
			return getIfStatement_2014ContainedLinks(view);
		case Expression2EditPart.VISUAL_ID:
			return getExpression_2015ContainedLinks(view);
		case WaitStatement4EditPart.VISUAL_ID:
			return getWaitStatement_2016ContainedLinks(view);
		case BreakStatement4EditPart.VISUAL_ID:
			return getBreakStatement_2017ContainedLinks(view);
		case InvokeStatement4EditPart.VISUAL_ID:
			return getInvokeStatement_2018ContainedLinks(view);
		case IterationStatement3EditPart.VISUAL_ID:
			return getIterationStatement_2019ContainedLinks(view);
		case AssignmentStatementEditPart.VISUAL_ID:
			return getAssignmentStatement_2020ContainedLinks(view);
		case Expression3EditPart.VISUAL_ID:
			return getExpression_2021ContainedLinks(view);
		case InvokeStatement5EditPart.VISUAL_ID:
			return getInvokeStatement_2022ContainedLinks(view);
		case IfStatement2EditPart.VISUAL_ID:
			return getIfStatement_2023ContainedLinks(view);
		case AssignmentStatement2EditPart.VISUAL_ID:
			return getAssignmentStatement_2024ContainedLinks(view);
		case WaitStatement5EditPart.VISUAL_ID:
			return getWaitStatement_2025ContainedLinks(view);
		case BreakStatement5EditPart.VISUAL_ID:
			return getBreakStatement_2026ContainedLinks(view);
		case InvokeStatement6EditPart.VISUAL_ID:
			return getInvokeStatement_2027ContainedLinks(view);
		case IterationStatement4EditPart.VISUAL_ID:
			return getIterationStatement_2028ContainedLinks(view);
		case IfStatement3EditPart.VISUAL_ID:
			return getIfStatement_2029ContainedLinks(view);
		case AssignmentStatement3EditPart.VISUAL_ID:
			return getAssignmentStatement_2030ContainedLinks(view);
		case IfStatement4EditPart.VISUAL_ID:
			return getIfStatement_2031ContainedLinks(view);
		case AssignmentStatement4EditPart.VISUAL_ID:
			return getAssignmentStatement_2032ContainedLinks(view);
		case IterationStatement5EditPart.VISUAL_ID:
			return getIterationStatement_2033ContainedLinks(view);
		case IfStatement5EditPart.VISUAL_ID:
			return getIfStatement_2034ContainedLinks(view);
		case AssignmentStatement5EditPart.VISUAL_ID:
			return getAssignmentStatement_2035ContainedLinks(view);
		case BooleanLiteralEditPart.VISUAL_ID:
			return getBooleanLiteral_2036ContainedLinks(view);
		case DoubleLiteralEditPart.VISUAL_ID:
			return getDoubleLiteral_2037ContainedLinks(view);
		case IntegerLiteralEditPart.VISUAL_ID:
			return getIntegerLiteral_2038ContainedLinks(view);
		case StringLiteralEditPart.VISUAL_ID:
			return getStringLiteral_2039ContainedLinks(view);
		case BooleanLiteral2EditPart.VISUAL_ID:
			return getBooleanLiteral_2040ContainedLinks(view);
		case DoubleLiteral2EditPart.VISUAL_ID:
			return getDoubleLiteral_2041ContainedLinks(view);
		case IntegerLiteral2EditPart.VISUAL_ID:
			return getIntegerLiteral_2042ContainedLinks(view);
		case StringLiteral2EditPart.VISUAL_ID:
			return getStringLiteral_2043ContainedLinks(view);
		case EventAssignmentStatementEditPart.VISUAL_ID:
			return getEventAssignmentStatement_2044ContainedLinks(view);
		case WaitStatement6EditPart.VISUAL_ID:
			return getWaitStatement_2045ContainedLinks(view);
		case BreakStatement6EditPart.VISUAL_ID:
			return getBreakStatement_2046ContainedLinks(view);
		case InvokeStatement7EditPart.VISUAL_ID:
			return getInvokeStatement_2047ContainedLinks(view);
		case IterationStatement6EditPart.VISUAL_ID:
			return getIterationStatement_2048ContainedLinks(view);
		case IfStatement6EditPart.VISUAL_ID:
			return getIfStatement_2049ContainedLinks(view);
		case AssignmentStatement6EditPart.VISUAL_ID:
			return getAssignmentStatement_2050ContainedLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getIncomingLinks(View view) {
		switch (IpacadlVisualIDRegistry.getVisualID(view)) {
		case BodyEditPart.VISUAL_ID:
			return getBody_1001IncomingLinks(view);
		case VectorDeclarationEditPart.VISUAL_ID:
			return getVectorDeclaration_1002IncomingLinks(view);
		case VariableDeclarationEditPart.VISUAL_ID:
			return getVariableDeclaration_1003IncomingLinks(view);
		case ConstantDeclarationEditPart.VISUAL_ID:
			return getConstantDeclaration_1004IncomingLinks(view);
		case EventHandlerEditPart.VISUAL_ID:
			return getEventHandler_1005IncomingLinks(view);
		case WaitStatementEditPart.VISUAL_ID:
			return getWaitStatement_2001IncomingLinks(view);
		case BreakStatementEditPart.VISUAL_ID:
			return getBreakStatement_2002IncomingLinks(view);
		case InvokeStatementEditPart.VISUAL_ID:
			return getInvokeStatement_2003IncomingLinks(view);
		case FaultStatementEditPart.VISUAL_ID:
			return getFaultStatement_2004IncomingLinks(view);
		case WaitStatement2EditPart.VISUAL_ID:
			return getWaitStatement_2005IncomingLinks(view);
		case BreakStatement2EditPart.VISUAL_ID:
			return getBreakStatement_2006IncomingLinks(view);
		case InvokeStatement2EditPart.VISUAL_ID:
			return getInvokeStatement_2007IncomingLinks(view);
		case IterationStatementEditPart.VISUAL_ID:
			return getIterationStatement_2008IncomingLinks(view);
		case ExpressionEditPart.VISUAL_ID:
			return getExpression_2009IncomingLinks(view);
		case WaitStatement3EditPart.VISUAL_ID:
			return getWaitStatement_2010IncomingLinks(view);
		case BreakStatement3EditPart.VISUAL_ID:
			return getBreakStatement_2011IncomingLinks(view);
		case InvokeStatement3EditPart.VISUAL_ID:
			return getInvokeStatement_2012IncomingLinks(view);
		case IterationStatement2EditPart.VISUAL_ID:
			return getIterationStatement_2013IncomingLinks(view);
		case IfStatementEditPart.VISUAL_ID:
			return getIfStatement_2014IncomingLinks(view);
		case Expression2EditPart.VISUAL_ID:
			return getExpression_2015IncomingLinks(view);
		case WaitStatement4EditPart.VISUAL_ID:
			return getWaitStatement_2016IncomingLinks(view);
		case BreakStatement4EditPart.VISUAL_ID:
			return getBreakStatement_2017IncomingLinks(view);
		case InvokeStatement4EditPart.VISUAL_ID:
			return getInvokeStatement_2018IncomingLinks(view);
		case IterationStatement3EditPart.VISUAL_ID:
			return getIterationStatement_2019IncomingLinks(view);
		case AssignmentStatementEditPart.VISUAL_ID:
			return getAssignmentStatement_2020IncomingLinks(view);
		case Expression3EditPart.VISUAL_ID:
			return getExpression_2021IncomingLinks(view);
		case InvokeStatement5EditPart.VISUAL_ID:
			return getInvokeStatement_2022IncomingLinks(view);
		case IfStatement2EditPart.VISUAL_ID:
			return getIfStatement_2023IncomingLinks(view);
		case AssignmentStatement2EditPart.VISUAL_ID:
			return getAssignmentStatement_2024IncomingLinks(view);
		case WaitStatement5EditPart.VISUAL_ID:
			return getWaitStatement_2025IncomingLinks(view);
		case BreakStatement5EditPart.VISUAL_ID:
			return getBreakStatement_2026IncomingLinks(view);
		case InvokeStatement6EditPart.VISUAL_ID:
			return getInvokeStatement_2027IncomingLinks(view);
		case IterationStatement4EditPart.VISUAL_ID:
			return getIterationStatement_2028IncomingLinks(view);
		case IfStatement3EditPart.VISUAL_ID:
			return getIfStatement_2029IncomingLinks(view);
		case AssignmentStatement3EditPart.VISUAL_ID:
			return getAssignmentStatement_2030IncomingLinks(view);
		case IfStatement4EditPart.VISUAL_ID:
			return getIfStatement_2031IncomingLinks(view);
		case AssignmentStatement4EditPart.VISUAL_ID:
			return getAssignmentStatement_2032IncomingLinks(view);
		case IterationStatement5EditPart.VISUAL_ID:
			return getIterationStatement_2033IncomingLinks(view);
		case IfStatement5EditPart.VISUAL_ID:
			return getIfStatement_2034IncomingLinks(view);
		case AssignmentStatement5EditPart.VISUAL_ID:
			return getAssignmentStatement_2035IncomingLinks(view);
		case BooleanLiteralEditPart.VISUAL_ID:
			return getBooleanLiteral_2036IncomingLinks(view);
		case DoubleLiteralEditPart.VISUAL_ID:
			return getDoubleLiteral_2037IncomingLinks(view);
		case IntegerLiteralEditPart.VISUAL_ID:
			return getIntegerLiteral_2038IncomingLinks(view);
		case StringLiteralEditPart.VISUAL_ID:
			return getStringLiteral_2039IncomingLinks(view);
		case BooleanLiteral2EditPart.VISUAL_ID:
			return getBooleanLiteral_2040IncomingLinks(view);
		case DoubleLiteral2EditPart.VISUAL_ID:
			return getDoubleLiteral_2041IncomingLinks(view);
		case IntegerLiteral2EditPart.VISUAL_ID:
			return getIntegerLiteral_2042IncomingLinks(view);
		case StringLiteral2EditPart.VISUAL_ID:
			return getStringLiteral_2043IncomingLinks(view);
		case EventAssignmentStatementEditPart.VISUAL_ID:
			return getEventAssignmentStatement_2044IncomingLinks(view);
		case WaitStatement6EditPart.VISUAL_ID:
			return getWaitStatement_2045IncomingLinks(view);
		case BreakStatement6EditPart.VISUAL_ID:
			return getBreakStatement_2046IncomingLinks(view);
		case InvokeStatement7EditPart.VISUAL_ID:
			return getInvokeStatement_2047IncomingLinks(view);
		case IterationStatement6EditPart.VISUAL_ID:
			return getIterationStatement_2048IncomingLinks(view);
		case IfStatement6EditPart.VISUAL_ID:
			return getIfStatement_2049IncomingLinks(view);
		case AssignmentStatement6EditPart.VISUAL_ID:
			return getAssignmentStatement_2050IncomingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutgoingLinks(View view) {
		switch (IpacadlVisualIDRegistry.getVisualID(view)) {
		case BodyEditPart.VISUAL_ID:
			return getBody_1001OutgoingLinks(view);
		case VectorDeclarationEditPart.VISUAL_ID:
			return getVectorDeclaration_1002OutgoingLinks(view);
		case VariableDeclarationEditPart.VISUAL_ID:
			return getVariableDeclaration_1003OutgoingLinks(view);
		case ConstantDeclarationEditPart.VISUAL_ID:
			return getConstantDeclaration_1004OutgoingLinks(view);
		case EventHandlerEditPart.VISUAL_ID:
			return getEventHandler_1005OutgoingLinks(view);
		case WaitStatementEditPart.VISUAL_ID:
			return getWaitStatement_2001OutgoingLinks(view);
		case BreakStatementEditPart.VISUAL_ID:
			return getBreakStatement_2002OutgoingLinks(view);
		case InvokeStatementEditPart.VISUAL_ID:
			return getInvokeStatement_2003OutgoingLinks(view);
		case FaultStatementEditPart.VISUAL_ID:
			return getFaultStatement_2004OutgoingLinks(view);
		case WaitStatement2EditPart.VISUAL_ID:
			return getWaitStatement_2005OutgoingLinks(view);
		case BreakStatement2EditPart.VISUAL_ID:
			return getBreakStatement_2006OutgoingLinks(view);
		case InvokeStatement2EditPart.VISUAL_ID:
			return getInvokeStatement_2007OutgoingLinks(view);
		case IterationStatementEditPart.VISUAL_ID:
			return getIterationStatement_2008OutgoingLinks(view);
		case ExpressionEditPart.VISUAL_ID:
			return getExpression_2009OutgoingLinks(view);
		case WaitStatement3EditPart.VISUAL_ID:
			return getWaitStatement_2010OutgoingLinks(view);
		case BreakStatement3EditPart.VISUAL_ID:
			return getBreakStatement_2011OutgoingLinks(view);
		case InvokeStatement3EditPart.VISUAL_ID:
			return getInvokeStatement_2012OutgoingLinks(view);
		case IterationStatement2EditPart.VISUAL_ID:
			return getIterationStatement_2013OutgoingLinks(view);
		case IfStatementEditPart.VISUAL_ID:
			return getIfStatement_2014OutgoingLinks(view);
		case Expression2EditPart.VISUAL_ID:
			return getExpression_2015OutgoingLinks(view);
		case WaitStatement4EditPart.VISUAL_ID:
			return getWaitStatement_2016OutgoingLinks(view);
		case BreakStatement4EditPart.VISUAL_ID:
			return getBreakStatement_2017OutgoingLinks(view);
		case InvokeStatement4EditPart.VISUAL_ID:
			return getInvokeStatement_2018OutgoingLinks(view);
		case IterationStatement3EditPart.VISUAL_ID:
			return getIterationStatement_2019OutgoingLinks(view);
		case AssignmentStatementEditPart.VISUAL_ID:
			return getAssignmentStatement_2020OutgoingLinks(view);
		case Expression3EditPart.VISUAL_ID:
			return getExpression_2021OutgoingLinks(view);
		case InvokeStatement5EditPart.VISUAL_ID:
			return getInvokeStatement_2022OutgoingLinks(view);
		case IfStatement2EditPart.VISUAL_ID:
			return getIfStatement_2023OutgoingLinks(view);
		case AssignmentStatement2EditPart.VISUAL_ID:
			return getAssignmentStatement_2024OutgoingLinks(view);
		case WaitStatement5EditPart.VISUAL_ID:
			return getWaitStatement_2025OutgoingLinks(view);
		case BreakStatement5EditPart.VISUAL_ID:
			return getBreakStatement_2026OutgoingLinks(view);
		case InvokeStatement6EditPart.VISUAL_ID:
			return getInvokeStatement_2027OutgoingLinks(view);
		case IterationStatement4EditPart.VISUAL_ID:
			return getIterationStatement_2028OutgoingLinks(view);
		case IfStatement3EditPart.VISUAL_ID:
			return getIfStatement_2029OutgoingLinks(view);
		case AssignmentStatement3EditPart.VISUAL_ID:
			return getAssignmentStatement_2030OutgoingLinks(view);
		case IfStatement4EditPart.VISUAL_ID:
			return getIfStatement_2031OutgoingLinks(view);
		case AssignmentStatement4EditPart.VISUAL_ID:
			return getAssignmentStatement_2032OutgoingLinks(view);
		case IterationStatement5EditPart.VISUAL_ID:
			return getIterationStatement_2033OutgoingLinks(view);
		case IfStatement5EditPart.VISUAL_ID:
			return getIfStatement_2034OutgoingLinks(view);
		case AssignmentStatement5EditPart.VISUAL_ID:
			return getAssignmentStatement_2035OutgoingLinks(view);
		case BooleanLiteralEditPart.VISUAL_ID:
			return getBooleanLiteral_2036OutgoingLinks(view);
		case DoubleLiteralEditPart.VISUAL_ID:
			return getDoubleLiteral_2037OutgoingLinks(view);
		case IntegerLiteralEditPart.VISUAL_ID:
			return getIntegerLiteral_2038OutgoingLinks(view);
		case StringLiteralEditPart.VISUAL_ID:
			return getStringLiteral_2039OutgoingLinks(view);
		case BooleanLiteral2EditPart.VISUAL_ID:
			return getBooleanLiteral_2040OutgoingLinks(view);
		case DoubleLiteral2EditPart.VISUAL_ID:
			return getDoubleLiteral_2041OutgoingLinks(view);
		case IntegerLiteral2EditPart.VISUAL_ID:
			return getIntegerLiteral_2042OutgoingLinks(view);
		case StringLiteral2EditPart.VISUAL_ID:
			return getStringLiteral_2043OutgoingLinks(view);
		case EventAssignmentStatementEditPart.VISUAL_ID:
			return getEventAssignmentStatement_2044OutgoingLinks(view);
		case WaitStatement6EditPart.VISUAL_ID:
			return getWaitStatement_2045OutgoingLinks(view);
		case BreakStatement6EditPart.VISUAL_ID:
			return getBreakStatement_2046OutgoingLinks(view);
		case InvokeStatement7EditPart.VISUAL_ID:
			return getInvokeStatement_2047OutgoingLinks(view);
		case IterationStatement6EditPart.VISUAL_ID:
			return getIterationStatement_2048OutgoingLinks(view);
		case IfStatement6EditPart.VISUAL_ID:
			return getIfStatement_2049OutgoingLinks(view);
		case AssignmentStatement6EditPart.VISUAL_ID:
			return getAssignmentStatement_2050OutgoingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getApplication_79ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getBody_1001ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getVectorDeclaration_1002ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getVariableDeclaration_1003ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getConstantDeclaration_1004ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getEventHandler_1005ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2001ContainedLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2002ContainedLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2003ContainedLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getFaultStatement_2004ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2005ContainedLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2006ContainedLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2007ContainedLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2008ContainedLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExpression_2009ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2010ContainedLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2011ContainedLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2012ContainedLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2013ContainedLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2014ContainedLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExpression_2015ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2016ContainedLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2017ContainedLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2018ContainedLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2019ContainedLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2020ContainedLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExpression_2021ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2022ContainedLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2023ContainedLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2024ContainedLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2025ContainedLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2026ContainedLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2027ContainedLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2028ContainedLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2029ContainedLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2030ContainedLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2031ContainedLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2032ContainedLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2033ContainedLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2034ContainedLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2035ContainedLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBooleanLiteral_2036ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getDoubleLiteral_2037ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getIntegerLiteral_2038ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getStringLiteral_2039ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getBooleanLiteral_2040ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getDoubleLiteral_2041ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getIntegerLiteral_2042ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getStringLiteral_2043ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getEventAssignmentStatement_2044ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2045ContainedLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2046ContainedLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2047ContainedLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2048ContainedLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2049ContainedLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2050ContainedLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBody_1001IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getVectorDeclaration_1002IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getVariableDeclaration_1003IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getConstantDeclaration_1004IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getEventHandler_1005IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2001IncomingLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2002IncomingLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2003IncomingLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getFaultStatement_2004IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2005IncomingLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2006IncomingLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2007IncomingLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2008IncomingLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExpression_2009IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2010IncomingLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2011IncomingLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2012IncomingLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2013IncomingLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2014IncomingLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExpression_2015IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2016IncomingLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2017IncomingLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2018IncomingLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2019IncomingLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2020IncomingLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExpression_2021IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2022IncomingLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2023IncomingLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2024IncomingLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2025IncomingLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2026IncomingLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2027IncomingLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2028IncomingLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2029IncomingLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2030IncomingLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2031IncomingLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2032IncomingLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2033IncomingLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2034IncomingLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2035IncomingLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBooleanLiteral_2036IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getDoubleLiteral_2037IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getIntegerLiteral_2038IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getStringLiteral_2039IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getBooleanLiteral_2040IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getDoubleLiteral_2041IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getIntegerLiteral_2042IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getStringLiteral_2043IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getEventAssignmentStatement_2044IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2045IncomingLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2046IncomingLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2047IncomingLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2048IncomingLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2049IncomingLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2050IncomingLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBody_1001OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getVectorDeclaration_1002OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getVariableDeclaration_1003OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getConstantDeclaration_1004OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getEventHandler_1005OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2001OutgoingLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2002OutgoingLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2003OutgoingLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getFaultStatement_2004OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2005OutgoingLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2006OutgoingLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2007OutgoingLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2008OutgoingLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExpression_2009OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2010OutgoingLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2011OutgoingLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2012OutgoingLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2013OutgoingLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2014OutgoingLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExpression_2015OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2016OutgoingLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2017OutgoingLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2018OutgoingLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2019OutgoingLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2020OutgoingLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExpression_2021OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2022OutgoingLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2023OutgoingLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2024OutgoingLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2025OutgoingLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2026OutgoingLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2027OutgoingLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2028OutgoingLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2029OutgoingLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2030OutgoingLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2031OutgoingLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2032OutgoingLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2033OutgoingLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2034OutgoingLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2035OutgoingLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBooleanLiteral_2036OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getDoubleLiteral_2037OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getIntegerLiteral_2038OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getStringLiteral_2039OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getBooleanLiteral_2040OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getDoubleLiteral_2041OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getIntegerLiteral_2042OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getStringLiteral_2043OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getEventAssignmentStatement_2044OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getWaitStatement_2045OutgoingLinks(View view) {
		WaitStatement modelElement = (WaitStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBreakStatement_2046OutgoingLinks(View view) {
		BreakStatement modelElement = (BreakStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getInvokeStatement_2047OutgoingLinks(View view) {
		InvokeStatement modelElement = (InvokeStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIterationStatement_2048OutgoingLinks(View view) {
		IterationStatement modelElement = (IterationStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getIfStatement_2049OutgoingLinks(View view) {
		IfStatement modelElement = (IfStatement) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAssignmentStatement_2050OutgoingLinks(View view) {
		AssignmentStatement modelElement = (AssignmentStatement) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_Statement_Connection_3001(
			Statement target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == IpacadlPackage.eINSTANCE
					.getStatement_Connection()) {
				result.add(new IpacadlLinkDescriptor(setting.getEObject(),
						target, IpacadlElementTypes.StatementConnection_3001,
						StatementConnectionEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_Statement_Connection_3001(
			Statement source) {
		Collection result = new LinkedList();
		Statement destination = source.getConnection();
		if (destination == null) {
			return result;
		}
		result.add(new IpacadlLinkDescriptor(source, destination,
				IpacadlElementTypes.StatementConnection_3001,
				StatementConnectionEditPart.VISUAL_ID));
		return result;
	}

}
