package eu.ipac.ace.gmf.ipacadl.diagram.providers;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.modelingassistant.ModelingAssistantProvider;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.dialogs.ElementListSelectionDialog;

import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.ApplicationEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.AssignmentStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.BodyCompartmentStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.ConstantDeclarationEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.EventHandlerCompartmentEventHandlerStatementsPropertiesEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.FaultStatementCompartmentOnFaultStatementsEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentElseStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementCompartmentIfStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IfStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatement7EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.InvokeStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatement2EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatement3EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatement4EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatement5EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatement6EditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementCompartmentWhileStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.IterationStatementEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.edit.parts.VariableDeclarationEditPart;
import eu.ipac.ace.gmf.ipacadl.diagram.part.IpacadlDiagramEditorPlugin;
import eu.ipac.ace.gmf.ipacadl.diagram.part.Messages;

/**
 * @generated
 */
public class IpacadlModelingAssistantProvider extends ModelingAssistantProvider {

	/**
	 * @generated
	 */
	public List getTypesForPopupBar(IAdaptable host) {
		IGraphicalEditPart editPart = (IGraphicalEditPart) host
				.getAdapter(IGraphicalEditPart.class);
		if (editPart instanceof VariableDeclarationEditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.BooleanLiteral_2036);
			types.add(IpacadlElementTypes.DoubleLiteral_2037);
			types.add(IpacadlElementTypes.IntegerLiteral_2038);
			types.add(IpacadlElementTypes.StringLiteral_2039);
			return types;
		}
		if (editPart instanceof ConstantDeclarationEditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.BooleanLiteral_2040);
			types.add(IpacadlElementTypes.DoubleLiteral_2041);
			types.add(IpacadlElementTypes.IntegerLiteral_2042);
			types.add(IpacadlElementTypes.StringLiteral_2043);
			return types;
		}
		if (editPart instanceof InvokeStatementEditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.FaultStatement_2004);
			return types;
		}
		if (editPart instanceof InvokeStatement2EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.FaultStatement_2004);
			return types;
		}
		if (editPart instanceof IterationStatementEditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2009);
			return types;
		}
		if (editPart instanceof InvokeStatement3EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.FaultStatement_2004);
			return types;
		}
		if (editPart instanceof IterationStatement2EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2009);
			return types;
		}
		if (editPart instanceof IfStatementEditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2015);
			return types;
		}
		if (editPart instanceof InvokeStatement4EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.FaultStatement_2004);
			return types;
		}
		if (editPart instanceof IterationStatement3EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2009);
			return types;
		}
		if (editPart instanceof AssignmentStatementEditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2021);
			types.add(IpacadlElementTypes.InvokeStatement_2022);
			return types;
		}
		if (editPart instanceof InvokeStatement5EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.FaultStatement_2004);
			return types;
		}
		if (editPart instanceof IfStatement2EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2015);
			return types;
		}
		if (editPart instanceof AssignmentStatement2EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2021);
			types.add(IpacadlElementTypes.InvokeStatement_2022);
			return types;
		}
		if (editPart instanceof InvokeStatement6EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.FaultStatement_2004);
			return types;
		}
		if (editPart instanceof IterationStatement4EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2009);
			return types;
		}
		if (editPart instanceof IfStatement3EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2015);
			return types;
		}
		if (editPart instanceof AssignmentStatement3EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2021);
			types.add(IpacadlElementTypes.InvokeStatement_2022);
			return types;
		}
		if (editPart instanceof IfStatement4EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2015);
			return types;
		}
		if (editPart instanceof AssignmentStatement4EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2021);
			types.add(IpacadlElementTypes.InvokeStatement_2022);
			return types;
		}
		if (editPart instanceof IterationStatement5EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2009);
			return types;
		}
		if (editPart instanceof IfStatement5EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2015);
			return types;
		}
		if (editPart instanceof AssignmentStatement5EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2021);
			types.add(IpacadlElementTypes.InvokeStatement_2022);
			return types;
		}
		if (editPart instanceof InvokeStatement7EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.FaultStatement_2004);
			return types;
		}
		if (editPart instanceof IterationStatement6EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2009);
			return types;
		}
		if (editPart instanceof IfStatement6EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2015);
			return types;
		}
		if (editPart instanceof AssignmentStatement6EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Expression_2021);
			types.add(IpacadlElementTypes.InvokeStatement_2022);
			return types;
		}
		if (editPart instanceof BodyCompartmentStatementEditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2001);
			types.add(IpacadlElementTypes.BreakStatement_2002);
			types.add(IpacadlElementTypes.InvokeStatement_2003);
			types.add(IpacadlElementTypes.IterationStatement_2033);
			types.add(IpacadlElementTypes.IfStatement_2034);
			types.add(IpacadlElementTypes.AssignmentStatement_2035);
			return types;
		}
		if (editPart instanceof FaultStatementCompartmentOnFaultStatementsEditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2005);
			types.add(IpacadlElementTypes.BreakStatement_2006);
			types.add(IpacadlElementTypes.InvokeStatement_2007);
			types.add(IpacadlElementTypes.IterationStatement_2008);
			types.add(IpacadlElementTypes.IfStatement_2031);
			types.add(IpacadlElementTypes.AssignmentStatement_2032);
			return types;
		}
		if (editPart instanceof IterationStatementCompartmentWhileStatementEditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2010);
			types.add(IpacadlElementTypes.BreakStatement_2011);
			types.add(IpacadlElementTypes.InvokeStatement_2012);
			types.add(IpacadlElementTypes.IterationStatement_2013);
			types.add(IpacadlElementTypes.IfStatement_2014);
			types.add(IpacadlElementTypes.AssignmentStatement_2020);
			return types;
		}
		if (editPart instanceof IterationStatementCompartmentWhileStatement2EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2010);
			types.add(IpacadlElementTypes.BreakStatement_2011);
			types.add(IpacadlElementTypes.InvokeStatement_2012);
			types.add(IpacadlElementTypes.IterationStatement_2013);
			types.add(IpacadlElementTypes.IfStatement_2014);
			types.add(IpacadlElementTypes.AssignmentStatement_2020);
			return types;
		}
		if (editPart instanceof IfStatementCompartmentIfStatementEditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2016);
			types.add(IpacadlElementTypes.BreakStatement_2017);
			types.add(IpacadlElementTypes.InvokeStatement_2018);
			types.add(IpacadlElementTypes.IterationStatement_2019);
			types.add(IpacadlElementTypes.IfStatement_2023);
			types.add(IpacadlElementTypes.AssignmentStatement_2024);
			return types;
		}
		if (editPart instanceof IfStatementCompartmentElseStatementEditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2025);
			types.add(IpacadlElementTypes.BreakStatement_2026);
			types.add(IpacadlElementTypes.InvokeStatement_2027);
			types.add(IpacadlElementTypes.IterationStatement_2028);
			types.add(IpacadlElementTypes.IfStatement_2029);
			types.add(IpacadlElementTypes.AssignmentStatement_2030);
			return types;
		}
		if (editPart instanceof IterationStatementCompartmentWhileStatement3EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2010);
			types.add(IpacadlElementTypes.BreakStatement_2011);
			types.add(IpacadlElementTypes.InvokeStatement_2012);
			types.add(IpacadlElementTypes.IterationStatement_2013);
			types.add(IpacadlElementTypes.IfStatement_2014);
			types.add(IpacadlElementTypes.AssignmentStatement_2020);
			return types;
		}
		if (editPart instanceof IfStatementCompartmentIfStatement2EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2016);
			types.add(IpacadlElementTypes.BreakStatement_2017);
			types.add(IpacadlElementTypes.InvokeStatement_2018);
			types.add(IpacadlElementTypes.IterationStatement_2019);
			types.add(IpacadlElementTypes.IfStatement_2023);
			types.add(IpacadlElementTypes.AssignmentStatement_2024);
			return types;
		}
		if (editPart instanceof IfStatementCompartmentElseStatement2EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2025);
			types.add(IpacadlElementTypes.BreakStatement_2026);
			types.add(IpacadlElementTypes.InvokeStatement_2027);
			types.add(IpacadlElementTypes.IterationStatement_2028);
			types.add(IpacadlElementTypes.IfStatement_2029);
			types.add(IpacadlElementTypes.AssignmentStatement_2030);
			return types;
		}
		if (editPart instanceof IterationStatementCompartmentWhileStatement4EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2010);
			types.add(IpacadlElementTypes.BreakStatement_2011);
			types.add(IpacadlElementTypes.InvokeStatement_2012);
			types.add(IpacadlElementTypes.IterationStatement_2013);
			types.add(IpacadlElementTypes.IfStatement_2014);
			types.add(IpacadlElementTypes.AssignmentStatement_2020);
			return types;
		}
		if (editPart instanceof IfStatementCompartmentIfStatement3EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2016);
			types.add(IpacadlElementTypes.BreakStatement_2017);
			types.add(IpacadlElementTypes.InvokeStatement_2018);
			types.add(IpacadlElementTypes.IterationStatement_2019);
			types.add(IpacadlElementTypes.IfStatement_2023);
			types.add(IpacadlElementTypes.AssignmentStatement_2024);
			return types;
		}
		if (editPart instanceof IfStatementCompartmentElseStatement3EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2025);
			types.add(IpacadlElementTypes.BreakStatement_2026);
			types.add(IpacadlElementTypes.InvokeStatement_2027);
			types.add(IpacadlElementTypes.IterationStatement_2028);
			types.add(IpacadlElementTypes.IfStatement_2029);
			types.add(IpacadlElementTypes.AssignmentStatement_2030);
			return types;
		}
		if (editPart instanceof IfStatementCompartmentIfStatement4EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2016);
			types.add(IpacadlElementTypes.BreakStatement_2017);
			types.add(IpacadlElementTypes.InvokeStatement_2018);
			types.add(IpacadlElementTypes.IterationStatement_2019);
			types.add(IpacadlElementTypes.IfStatement_2023);
			types.add(IpacadlElementTypes.AssignmentStatement_2024);
			return types;
		}
		if (editPart instanceof IfStatementCompartmentElseStatement4EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2025);
			types.add(IpacadlElementTypes.BreakStatement_2026);
			types.add(IpacadlElementTypes.InvokeStatement_2027);
			types.add(IpacadlElementTypes.IterationStatement_2028);
			types.add(IpacadlElementTypes.IfStatement_2029);
			types.add(IpacadlElementTypes.AssignmentStatement_2030);
			return types;
		}
		if (editPart instanceof IterationStatementCompartmentWhileStatement5EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2010);
			types.add(IpacadlElementTypes.BreakStatement_2011);
			types.add(IpacadlElementTypes.InvokeStatement_2012);
			types.add(IpacadlElementTypes.IterationStatement_2013);
			types.add(IpacadlElementTypes.IfStatement_2014);
			types.add(IpacadlElementTypes.AssignmentStatement_2020);
			return types;
		}
		if (editPart instanceof IfStatementCompartmentIfStatement5EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2016);
			types.add(IpacadlElementTypes.BreakStatement_2017);
			types.add(IpacadlElementTypes.InvokeStatement_2018);
			types.add(IpacadlElementTypes.IterationStatement_2019);
			types.add(IpacadlElementTypes.IfStatement_2023);
			types.add(IpacadlElementTypes.AssignmentStatement_2024);
			return types;
		}
		if (editPart instanceof IfStatementCompartmentElseStatement5EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2025);
			types.add(IpacadlElementTypes.BreakStatement_2026);
			types.add(IpacadlElementTypes.InvokeStatement_2027);
			types.add(IpacadlElementTypes.IterationStatement_2028);
			types.add(IpacadlElementTypes.IfStatement_2029);
			types.add(IpacadlElementTypes.AssignmentStatement_2030);
			return types;
		}
		if (editPart instanceof EventHandlerCompartmentEventHandlerStatementsPropertiesEditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.EventAssignmentStatement_2044);
			types.add(IpacadlElementTypes.WaitStatement_2045);
			types.add(IpacadlElementTypes.BreakStatement_2046);
			types.add(IpacadlElementTypes.InvokeStatement_2047);
			types.add(IpacadlElementTypes.IterationStatement_2048);
			types.add(IpacadlElementTypes.IfStatement_2049);
			types.add(IpacadlElementTypes.AssignmentStatement_2050);
			return types;
		}
		if (editPart instanceof IterationStatementCompartmentWhileStatement6EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2010);
			types.add(IpacadlElementTypes.BreakStatement_2011);
			types.add(IpacadlElementTypes.InvokeStatement_2012);
			types.add(IpacadlElementTypes.IterationStatement_2013);
			types.add(IpacadlElementTypes.IfStatement_2014);
			types.add(IpacadlElementTypes.AssignmentStatement_2020);
			return types;
		}
		if (editPart instanceof IfStatementCompartmentIfStatement6EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2016);
			types.add(IpacadlElementTypes.BreakStatement_2017);
			types.add(IpacadlElementTypes.InvokeStatement_2018);
			types.add(IpacadlElementTypes.IterationStatement_2019);
			types.add(IpacadlElementTypes.IfStatement_2023);
			types.add(IpacadlElementTypes.AssignmentStatement_2024);
			return types;
		}
		if (editPart instanceof IfStatementCompartmentElseStatement6EditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.WaitStatement_2025);
			types.add(IpacadlElementTypes.BreakStatement_2026);
			types.add(IpacadlElementTypes.InvokeStatement_2027);
			types.add(IpacadlElementTypes.IterationStatement_2028);
			types.add(IpacadlElementTypes.IfStatement_2029);
			types.add(IpacadlElementTypes.AssignmentStatement_2030);
			return types;
		}
		if (editPart instanceof ApplicationEditPart) {
			List types = new ArrayList();
			types.add(IpacadlElementTypes.Body_1001);
			types.add(IpacadlElementTypes.VectorDeclaration_1002);
			types.add(IpacadlElementTypes.VariableDeclaration_1003);
			types.add(IpacadlElementTypes.ConstantDeclaration_1004);
			types.add(IpacadlElementTypes.EventHandler_1005);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnSource(IAdaptable source) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
				.getAdapter(IGraphicalEditPart.class);
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnTarget(IAdaptable target) {
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
				.getAdapter(IGraphicalEditPart.class);
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnSourceAndTarget(IAdaptable source,
			IAdaptable target) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
				.getAdapter(IGraphicalEditPart.class);
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
				.getAdapter(IGraphicalEditPart.class);
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getTypesForSource(IAdaptable target,
			IElementType relationshipType) {
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
				.getAdapter(IGraphicalEditPart.class);
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getTypesForTarget(IAdaptable source,
			IElementType relationshipType) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
				.getAdapter(IGraphicalEditPart.class);
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForSource(IAdaptable target,
			IElementType relationshipType) {
		return selectExistingElement(target, getTypesForSource(target,
				relationshipType));
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForTarget(IAdaptable source,
			IElementType relationshipType) {
		return selectExistingElement(source, getTypesForTarget(source,
				relationshipType));
	}

	/**
	 * @generated
	 */
	protected EObject selectExistingElement(IAdaptable host, Collection types) {
		if (types.isEmpty()) {
			return null;
		}
		IGraphicalEditPart editPart = (IGraphicalEditPart) host
				.getAdapter(IGraphicalEditPart.class);
		if (editPart == null) {
			return null;
		}
		Diagram diagram = (Diagram) editPart.getRoot().getContents().getModel();
		Collection elements = new HashSet();
		for (Iterator it = diagram.getElement().eAllContents(); it.hasNext();) {
			EObject element = (EObject) it.next();
			if (isApplicableElement(element, types)) {
				elements.add(element);
			}
		}
		if (elements.isEmpty()) {
			return null;
		}
		return selectElement((EObject[]) elements.toArray(new EObject[elements
				.size()]));
	}

	/**
	 * @generated
	 */
	protected boolean isApplicableElement(EObject element, Collection types) {
		IElementType type = ElementTypeRegistry.getInstance().getElementType(
				element);
		return types.contains(type);
	}

	/**
	 * @generated
	 */
	protected EObject selectElement(EObject[] elements) {
		Shell shell = Display.getCurrent().getActiveShell();
		ILabelProvider labelProvider = new AdapterFactoryLabelProvider(
				IpacadlDiagramEditorPlugin.getInstance()
						.getItemProvidersAdapterFactory());
		ElementListSelectionDialog dialog = new ElementListSelectionDialog(
				shell, labelProvider);
		dialog.setMessage(Messages.IpacadlModelingAssistantProviderMessage);
		dialog.setTitle(Messages.IpacadlModelingAssistantProviderTitle);
		dialog.setMultipleSelection(false);
		dialog.setElements(elements);
		EObject selected = null;
		if (dialog.open() == Window.OK) {
			selected = (EObject) dialog.getFirstResult();
		}
		return selected;
	}
}
